﻿#include "stdafx.h"
#include "resource.h"
#include "NeMessengerDlg.h"
#include "WorkGroupController.h"
#include "ChatUser.h"
#include "MenuXP.h"
#include "MemoSendDlg.h"
#include "netlistmgr.h"
#include "NoteModel.h"
#include "ChatDialogManager.h"
#include "SendNoteMananger.h"
#include "ReceivedNoteManager.h" 
#include <wtsapi32.h>
#include "PeriodicEventHandler.h"
#include "XHyperLink.h"
#include "DialPadManager.h"
#include "SelectTelnoDlg.h"
#include "CallerInfoDlg.h"
#include "TimerManager.h"
#include "ChangeNoticeController.h"
#include "ChangeNoticePushController.h"
#include "ChangeNoticeDialogManager.h"
#include "NoticeController.h"
#include "UpdateNoticeController.h"
#include "..\..\DuiLib\UIlib.h"
#include "main_frame.hpp"
#include "ProfileWnd.h"
#include "DuiTrayPopup.h"
#include "ServerAddrConfig.h"

using namespace DuiLib;
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define IPT_RET_FALSE	0
#define IPT_RET_TRUE	1
#define  MAX_MESSAGEBOX_COUNT 10

CComModule _Module;

CNeMessengerDlg::CNeMessengerDlg(CWnd* pParent /*=NULL*/)
	: CSkinDialog(CNeMessengerDlg::IDD, pParent)		
	, m_bTopMost(FALSE)
	, m_pWorkGroupController(new WorkGroupController())
	, m_pProfileDlgController(new CProfileDlgController())
	, m_bLogin(FALSE)
	, m_bRetryLoginWithInterval(FALSE)
	, m_IdleMonitor(new CIdleMonitor())
	, m_pPeriodicEventHandler(NULL)
	, m_nRetryLoginInterval(3000)
	, m_pMailModel(new CMailModel())
	, m_pCallHistoryDlg(NULL)
	, m_strCID(_T(""))
	, m_nForwardingStatus(0)
	, m_strRequestedFwdTelNo(_T(""))
	, m_nDndStatus(0)
	, m_nHoldStatus(0)
	, m_pLanuageActorEvent(new CLanuageActorEvent())
	//, m_pCallerInfoDlg(NULL)
	, m_bRequestPhoneStatus(FALSE)
	, m_isCheckingUpdate(FALSE)
	, m_bUpdateStatus(FALSE)
	, m_pFrame(NULL)
	, m_pDlgSetting(NULL)
	, m_pAboutWnd(NULL)
	, m_bRestore(FALSE)
{
	srand( (unsigned)time( NULL ) );
	m_rcWindowBeforeLogOut.SetRectEmpty();
	m_rcWindowMaxRestore.SetRectEmpty();
	m_bWindowZoomedBeforeLogOut = false;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	g_pMain = this;	
	g_bFavoriteListDlgOpened = false;
	m_bUserBottomButton = FALSE;
	SetDelayRestore(TRUE);
	m_noteHandle = 0;
    //m_nSendMemo = 0;
    m_nHotkeyAltMID = 0;
    _clipBoardFormat = 0;
}


CNeMessengerDlg::~CNeMessengerDlg()
{
	if (m_pFrame!=NULL)
	{
		delete m_pFrame;
		m_pFrame = NULL;
	}
	if (g_pProfileWnd != NULL)
	{
		::DestroyWindow(g_pProfileWnd->GetHWND());
		delete g_pProfileWnd;
		g_pProfileWnd = NULL;
	}
	delete m_pWorkGroupController;
	delete m_pProfileDlgController;
	delete m_IdleMonitor;
	delete m_pLanuageActorEvent;
	if (NULL != m_pMailModel)
	{
		delete m_pMailModel;
	}
	
	CloseCallHistoryDlg();
	//CloseCallerInfoDlg();
}

void CNeMessengerDlg::DoDataExchange(CDataExchange* pDX)
{
	CSkinDialog::DoDataExchange(pDX);									
}

BEGIN_MESSAGE_MAP(CNeMessengerDlg, CSkinDialog)
	// Message
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_TRAYNOTIFY, OnTrayNotification)
	ON_MESSAGE(WM_EXITCHATDLG, OnExitChatDlg)		
	ON_MESSAGE(WM_EXITMEMODLG, OnExitSendMemoDlg)
	ON_MESSAGE(WM_EXITRECVMEMODLG,OnExitRecvMemoDlg)
	ON_MESSAGE(WM_CLICKMEMOPOPUP, OnMemoTrayPopup)	
	ON_MESSAGE(WM_CLICKMEMOFOCUS, OnMemoTrayPopupFocus)	
	ON_MESSAGE(WM_NOTEDLGMAX, OnNoteDlgMax)
	ON_MESSAGE(WM_TRAY_CLICK_MAIL, OnMailTrayPopup)
	ON_MESSAGE(WM_CLICKBUDDYONLINEPOPUP, OnBuddyOnlineTrayPopup)
	ON_MESSAGE(WM_NTALK_DEINITIALIZE, OnNTalkDeInitialize)
	ON_MESSAGE(WM_DESKTOP_IDLE, OnDesktopIdle)
	ON_MESSAGE(WM_TINY_WEBSERVER, OnTinyServerMessage)
	ON_MESSAGE(UM_INFO_ABOUTME_STATUS, OnTrayChangeStatus)
	ON_MESSAGE(UM_NTALK_NOTIFY_VERSION, OnNTalkNotifyVersion)
	ON_MESSAGE(MSG_CLOSE_SETTING_FRAME, OnCloseSettingFrame)
	ON_MESSAGE(MSG_RESTART_APP, OnRestartApp)
	ON_BN_CLICKED(IDC_SEARCH_BUTTON, &CNeMessengerDlg::OnBnClickedSearchButton)
	ON_REGISTERED_MESSAGE(WM_TI_TASKBARCREATED, OnTaskBarCreated)

	// Command
	ON_COMMAND(ID__LOGOUT, &CNeMessengerDlg::OnTopMenuLogout)
	ON_COMMAND(ID__ALWAYSTOP, &CNeMessengerDlg::OnTopMenuAlwaysTop)
	ON_COMMAND(ID__MYINFO, &CNeMessengerDlg::OnTopMenuMyInfo)
	ON_COMMAND(ID__WEB_SERVICE,&CNeMessengerDlg::DoInfoItemNote)
    ON_COMMAND(IDC_NOTE_LABEL,&CNeMessengerDlg::DoOpenWebNote)
	ON_COMMAND(ID__EXIT, &CNeMessengerDlg::OnTopMenuExit)
	ON_COMMAND(ID__CHAT, &CNeMessengerDlg::OnTopMenuChat)
	ON_COMMAND(ID__SMS, &CNeMessengerDlg::OnTopMenuSMS)
	ON_COMMAND(ID__MAKE_CALL, &CNeMessengerDlg::OnTopMenuMakeCall)
	ON_COMMAND(ID__ANSWER_CALL, &CNeMessengerDlg::OnTopMenuAnswerCall)
	ON_COMMAND(ID__CLEAR_CONNECTION, &CNeMessengerDlg::OnTopMenuClearConnection)
	ON_COMMAND(ID__HOLD_CALL, &CNeMessengerDlg::OnTopMenuHoldCall)
	ON_COMMAND(ID__RETRIEVE_CALL, &CNeMessengerDlg::OnTopMenuRetrieveCall)
	ON_COMMAND(ID__FORWARDING, &CNeMessengerDlg::OnTopMenuForwarding)
	ON_COMMAND(ID_IPT_CALLTRANSFER, &CNeMessengerDlg::OnTopMenuCallTransfer)
	ON_COMMAND(ID__DO_NOT_DISTURB_TRUE, &CNeMessengerDlg::OnTopMenuDoNotDisturbTrue)
	ON_COMMAND(ID__DO_NOT_DISTURB_FALSE, &CNeMessengerDlg::OnTopMenuDoNotDisturbFalse)
	ON_COMMAND(ID__CONFERENCE_CALL, &CNeMessengerDlg::OnTopMenuConferenceCall)
	ON_COMMAND(ID__SEND_MEMO, &CNeMessengerDlg::OnTopMenuSendMemo)
	ON_COMMAND(ID__VIEW_ORGANIZATIONCHART, &CNeMessengerDlg::OnTopMenuViewOrganizationChart)
	ON_COMMAND(ID__VIEW_WORKGROUP, &CNeMessengerDlg::OnTopMenuViewWorkGroup)	
	ON_COMMAND(ID__DEL, &CNeMessengerDlg::OnTopMenuDel)
	ON_COMMAND(ID__MAKE_GROUP, &CNeMessengerDlg::OnTopMenuMakeGroup)
	ON_COMMAND(ID__RENAME_GROUP, &CNeMessengerDlg::OnTopMenuRenameGroup)
	ON_COMMAND(ID__DEL_GROUP, &CNeMessengerDlg::OnTopMenuDelGroup)
	ON_COMMAND(ID__MANAGE_MEMO, &CNeMessengerDlg::OnTopMenuManageMemo)
	ON_COMMAND(ID__MANAGE_CONFIG, &CNeMessengerDlg::OnTopMenuManageConfig)
	ON_COMMAND(ID__MANAGE_CALL, &CNeMessengerDlg::OnTopMenuManageCall)
	ON_COMMAND(ID__ABOUT, &CNeMessengerDlg::OnTopMenuAbout)
	ON_COMMAND(ID__HELP_NEMESSENGER, &CNeMessengerDlg::OnTopMenuHelpNeMessenger)
	ON_COMMAND(ID__UPDATE, &CNeMessengerDlg::OnUpdate)
	ON_COMMAND(ID__TRAYSETTING, &CNeMessengerDlg::OnTraySetting)
	ON_COMMAND(ID__MNLOGIN, &CNeMessengerDlg::OnTrayLogin)
	ON_COMMAND(ID__MNLOGOUT, &CNeMessengerDlg::OnTrayLogout)
	ON_COMMAND(ID__MNOPEN, &CNeMessengerDlg::OnTrayOpen)
	ON_COMMAND(ID__MNCLOSE, &CNeMessengerDlg::OnTrayExit)	
	ON_COMMAND(ID__MANAGE_AUTOTEXT, &CNeMessengerDlg::OnTopMenuManageAutoText)
	ON_COMMAND(ID__OPEN_DOWNLOAD_FOLDER, &CNeMessengerDlg::OnTopMenuOpenDownloadFolder)
	ON_COMMAND(32815, &CNeMessengerDlg::OnNMSendMemo)
//	ON_COMMAND(ID_FAVORITE_GROUP_IMPORT, &CNeMessengerDlg::OnTopMenuImportGroup)		
	ON_COMMAND_RANGE(ID_TOPMENU_COPYGROUPLIST_START, ID_TOPMENU_COPYGROUPLIST_START + 999, &CNeMessengerDlg::OnTopMenuFavoriteCopy)
	ON_COMMAND_RANGE(ID_TOPMENU_MOVEGROUPLIST_START, ID_TOPMENU_MOVEGROUPLIST_START + 999, &CNeMessengerDlg::OnTopMenuFavoriteMove)
	ON_COMMAND(ID_FAVORITE_USER_CHAT_HISTORY, &CNeMessengerDlg::OnChatHistory)

	// WM
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_MEASUREITEM()
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_MENUCHAR()
	ON_WM_COPYDATA()
	ON_WM_HOTKEY()
	ON_WM_ACTIVATE()
	ON_WM_POWERBROADCAST()
	ON_WM_TIMER()
	ON_WM_SETFOCUS()
	ON_WM_ENDSESSION()
	ON_WM_WTSSESSION_CHANGE()
	ON_WM_MOVING()
	ON_WM_MOVE()
	ON_WM_CLOSE()
END_MESSAGE_MAP()

// CNeMessengerDlg 메시지 처리기
void CNeMessengerDlg::__ResourceLoad(BOOL bInit)
{
	SetLeftTopBitmap(GetAppImgFile(_T("img_login_title_l.bmp")));
	SetCenterTopBitmap(GetAppImgFile(_T("img_login_title_c.bmp")));
	SetRightTopBitmap(GetAppImgFile(_T("img_login_title_r.bmp")));

	SetLeftBorderBitmap(GetAppImgFile(_T("new_02_left.bmp")));
	SetRightBorderBitmap(GetAppImgFile(_T("new_02_right.bmp")));

	SetLeftBottomBitmap(GetAppImgFile(_T("new_02_bottom_left.bmp")));
	SetCenterBottomBitmap(GetAppImgFile(_T("new_02_bottom.bmp")));
	SetRightBottomBitmap(GetAppImgFile(_T("new_02_bottom_right.bmp")));

	/*SetRestoreBitmaps(GetAppImgFile(_T("new_restore.bmp")),
		GetAppImgFile(_T("new_restore_over.bmp")),
		GetAppImgFile(_T("new_restore_click.bmp")));

	SetMaxBitmaps(GetAppImgFile(_T("new_max.bmp")),
		GetAppImgFile(_T("new_max_over.bmp")),
		GetAppImgFile(_T("new_max_click.bmp")));*/

	SetMinBitmaps(GetAppImgFile(_T("btn_common_minimal_nor.bmp")), 
		GetAppImgFile(_T("btn_common_minimal_foc.bmp")), 
		GetAppImgFile(_T("btn_common_minimal_pre.bmp")));

	SetExitBitmaps(GetAppImgFile(_T("btn_common_cancel_nor.bmp")),
		GetAppImgFile(_T("btn_common_cancel_foc.bmp")), GetAppImgFile(_T("btn_common_cancel_pre.bmp")));

	SetCustomBitmaps(GetAppImgFile(_T("new_main_menu.bmp")), 
		GetAppImgFile(_T("new_main_menu_over.bmp")), 
		GetAppImgFile(_T("new_main_menu_click.bmp")));

	if (bInit == FALSE)
		SendMessage(WM_SIZE, NULL, NULL);

}

BOOL CNeMessengerDlg::OnInitDialog()
{
	CSkinDialog::OnInitDialog();

	ModifyStyle(0, WS_CLIPCHILDREN);
	ModifyStyle(WS_MAXIMIZEBOX, 0);
	

	// 시스템 메뉴에 "정보..." 메뉴 항목을 추가합니다.

	// IDM_ABOUTBOX는 시스템 명령 범위에 있어야 합니다.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	// 이 대화 상자의 아이콘을 설정합니다. 응용 프로그램의 주 창이 대화 상자가 아닐 경우에는
	//  프레임워크가 이 작업을 자동으로 수행합니다.
	SetIcon(m_hIcon, TRUE);			// 큰 아이콘을 설정합니다.
	SetIcon(m_hIcon, FALSE);		// 작은 아이콘을 설정합니다.
		
	// 핫키 등록
	m_nHotkeyAltMID = 0;

/*#ifndef _DEBUG
	::RegisterHotKey(this->GetSafeHwnd(), m_nHotkeyAltMID, MOD_ALT, _T('M'));	
#endif*/
	

	CNMImgComboBox::SetUnitedButtonImagesStatic(GetAppImgFile(_T("combo_box.bmp")),4);
	CNMImgComboBox::SetFontStatic(&g_ftDefault9PT);
	CNMImgComboBox::SetDropDownResizing();
	CNMImgComboBox::SetDefaultItemHeight(19);

	//CNMImgRadioButton::LoadUnitedImages(GetAppImgFile(_T("radiobutton.bmp")));


	_clipBoardFormat = RegisterClipboardFormat(_T("CF_NTALK_ID"));
	
	SetWindowText(MAIN_CAPTION_NAME);
	SetShowTitle(FALSE);
	g_pMessengerActor->RegisterObserver(this);
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	pWASActor->RegisterObserver(this);

	GET_APP()->SetWindowRegion(this);

	m_LoginDlg.SetParent(this);
	g_pMain= this;
	m_LoginDlg.Create(CLoginDlg::IDD);
	m_LoginDlg.ShowWindow(SW_SHOW);			
//	CTrayPopup::SetTextColor(RGB(51, 51, 51));	

	//m_LoginDlg.SetImgBGPath(_T("img_login_bg.png"));
	m_LoginDlg.SetImgLogoPath(_T("Login_Logo.png"));
	m_LoginDlg.SetImgInput_BGPath(_T("img_login_bg.png"));
	m_LoginDlg.SetHanaTourLogoPath(_T("img_bottom_logo.png"));
	m_LoginDlg.SetCopyrightLogoPath(_T("img_nts_copy.png"));
	m_LoginDlg.SetImgAutoLoginCheckPath(_T("Login_Checkbox_Unchecked.png"), _T("Login_Checkbox_Checked.png"));
	m_LoginDlg.SetImgChangeNoticeIconBluePath(_T("icon_notice20_b.png"));
	m_LoginDlg.SetImgChangeNoticeIconOrangePath(_T("icon_notice20_y.png"));
	m_LoginDlg.SetImgChangeNoticeIconRedPath(_T("icon_notice20_r.png"));
	m_LoginDlg.SetImgChangeNoticeBGPath(_T("img_login_note_bg.png"));

	if (g_stNtalkInfo.strId.IsEmpty())
		m_LoginDlg.SetIDTitle(LoadStringFromResource(IDS_STRING239));
	else
		m_LoginDlg.SetIDTitle(g_stNtalkInfo.strId);

	CString strText = _T("");
	strText.LoadString(IDS_STRING240);
	m_LoginDlg.SetPasswordTitle(strText);
	strText.LoadString(IDS_STRING241);
	m_LoginDlg.SetAutoLoginCheckTitle(strText);
	
	m_TrayIcon.Create(this, IDR_MENU_KOREAN, MAIN_CAPTION_NAME, AfxGetApp()->LoadIcon(IDI_IC_TRAY_OFFLINE), WM_TRAYNOTIFY);
	m_TrayIcon.SetLogin(FALSE);
	
	// 간혹 트레이 아이콘의 상태가 변경되지 않는 경우가 있다고 하여 1분마다 강제로 갱신을 해주기 위한 타이머를 셋팅한다.
	SetTimer(TIMER_REFRESH_TRAYICON, 1000 * 60, NULL);	

	__ResourceLoad(TRUE);
	SetWindowMinSize(DEF_MIN_SIZE_WIDTH, DEF_MIN_SIZE_HEIGHT); //처음 로그인창은 더 줄이지 못하게	

	SetExitBtnActHide(TRUE); //exit버튼 클릭시 종료하지 말고 hide
	SetMoveTransParent(FALSE); //윈도우 이동시 투명하게 하지 않기

	Restore(this, false, _T("MainDialog"), Position, this);

	CRect rcWindow(0, 0, 0, 0);
	GetWindowRect(&rcWindow);
	rcWindow.right = rcWindow.left + DEF_MIN_SIZE_WIDTH;
	rcWindow.bottom = rcWindow.top + DEF_MIN_SIZE_HEIGHT;
	MoveWindow(rcWindow, TRUE);	

    TCHAR szModuleName[4096] = {0};
    TCHAR szDrive[_MAX_DRIVE] = {0};
    TCHAR szDir[_MAX_DIR] = {0};
    TCHAR szFName[_MAX_FNAME] = {0};
    TCHAR szExt[_MAX_EXT] = {0};
	CString strCurDir=_T("");

	GetModuleFileName(NULL, szModuleName, DIM(szModuleName));
	_tsplitpath_s(szModuleName, szDrive, _MAX_DRIVE, szDir, _MAX_DIR, szFName, _MAX_FNAME, szExt, _MAX_EXT);	
	strCurDir.Format(_T("%s%s"), szDrive, szDir);

	WTSRegisterSessionNotification(GetSafeHwnd(), NOTIFY_FOR_THIS_SESSION);
	RegisterPeriodicEventThread();

	SetLastPositionAndSize(this, _T("MainDialog"));

	// TimerManager 생성
	GET_APP()->CreateTimerManager(this);

	GET_APP()->m_pSendNoteManager->m_pSendNoteMemberInfoActorEvent->WasRegister();

	GET_APP()->m_pReceivedNoteManager->WasRegister();

	GET_APP()->m_pSendNoteManager->WasRegister();

	return TRUE;  // 포커스를 컨트롤에 설정하지 않으면 TRUE를 반환합니다.
}

void CNeMessengerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlg;
		CSingleLock modalBoxCountLock(&g_csModalBoxCount);
		modalBoxCountLock.Lock();
		++g_ModalBoxCount;
		modalBoxCountLock.Unlock();

        GET_MESSENGER_DLG()->RegisterMfcModalDlg(&dlg);
        int nRet = dlg.DoModal();
        GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&dlg);

		modalBoxCountLock.Lock();
		--g_ModalBoxCount;
		modalBoxCountLock.Unlock();
		
	}
	else
	{
		CSkinDialog::OnSysCommand(nID, lParam);
	}
}

// 대화 상자에 최소화 단추를 추가할 경우 아이콘을 그리려면
//  아래 코드가 필요합니다. 문서/뷰 모델을 사용하는 MFC 응용 프로그램의 경우에는
//  프레임워크에서 이 작업을 자동으로 수행합니다.

void CNeMessengerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 그리기를 위한 디바이스 컨텍스트

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 클라이언트 사각형에서 아이콘을 가운데에 맞춥니다.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect(0, 0, 0, 0);
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 아이콘을 그립니다.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);
	}
	CSkinDialog::OnPaint();
}

// 사용자가 최소화된 창을 끄는 동안에 커서가 표시되도록 시스템에서
//  이 함수를 호출합니다.
HCURSOR CNeMessengerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

LRESULT CNeMessengerDlg::OnTrayNotification(WPARAM wParam, LPARAM lParam)
{
	return m_TrayIcon.OnTrayNotification(wParam, lParam);
}

LRESULT CNeMessengerDlg::OnExitChatDlg(WPARAM wParam, LPARAM lParam)
{
	CChatDlg* pExitDlg = (CChatDlg*)lParam;
	CNeMessengerApp* pApp = (CNeMessengerApp*)AfxGetApp();
	pApp->m_pChatDialogManager->Remove((CDialog*)pExitDlg);
	pExitDlg->CloseChatDialog();

	return 0L;
}

LRESULT CNeMessengerDlg::OnExitRecvMemoDlg(WPARAM wParam, LPARAM lParam)
{
	CRecvMemoDlg* pExitDlg = (CRecvMemoDlg*)lParam;
	CNeMessengerApp* pApp = (CNeMessengerApp*)AfxGetApp();
	pApp->m_pReceivedNoteManager->Remove(pExitDlg);
	pExitDlg->DestroyWindow();

	return 0L;
}

LRESULT CNeMessengerDlg::OnExitSendMemoDlg(WPARAM wParam, LPARAM lParam)
{
	CMemoSendDlg* pExitDlg = (CMemoSendDlg*)lParam;
	CNeMessengerApp* pApp = (CNeMessengerApp*)AfxGetApp();
	pApp->m_pSendNoteManager->Remove(pExitDlg);
	pExitDlg->DestroyWindow();

	return 0L;
}

LRESULT CNeMessengerDlg::OnNTalkDeInitialize(WPARAM wParam, LPARAM lParam)
{	
	DeInitialize();

	return 0L;
}

// 로그아웃
void CNeMessengerDlg::OnTopMenuLogout()
{	
	LogOut();
}

// 항상 위
void CNeMessengerDlg::OnTopMenuAlwaysTop()
{
	if(m_bTopMost == FALSE)
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
	else if(m_bTopMost == TRUE)
		SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);	
	
	m_bTopMost = !m_bTopMost;

}

// 내정보
void CNeMessengerDlg::OnTopMenuMyInfo()
{
	GT_MY_USER_DATA myUserData;
 	g_pMessengerActor->GetMyUserInfo(myUserData);

	RECT rcNeMessengDlg = {0};
	GetWindowRect(&rcNeMessengDlg);

	RECT rcAround = {rcNeMessengDlg.left + 9, rcNeMessengDlg.top + 8, rcNeMessengDlg.left + 49, rcNeMessengDlg.top + 48};//skin.xml

	m_pProfileDlgController->CreateProfileDlg(myUserData.strUserID, rcAround, GetSafeHwnd());
}

void CNeMessengerDlg::DoInfoItemNote(){
  m_pFrame->DoInfoItemNote();
}

void CNeMessengerDlg::DoOpenWebNote(){
    //event click on tray pop window, now is same with DoInfoItemNote
    m_pFrame->DoInfoItemNote();
}

// 끝내기
void CNeMessengerDlg::OnTopMenuExit()
{
	m_pFrame->ReleaseChatRoomList();

//	GET_APP()->m_pChatDialogManager->CloseAllChatDialog(); // CloseAllChatDialog() is a unnecessary function.Same as RemoveAll();
//	GET_APP()->m_pChatDialogManager->SetNeedRestoreChatRoomID(true);

	int Success = GET_APP()->m_pChatDialogManager->RemoveAll();
	if (0 == Success)
	{
		CloseChildAll();
		CSkinDialog::OnOK();

	}
}

LRESULT CNeMessengerDlg::OnRestartApp(WPARAM wParam,LPARAM lParam)
{
	if (m_pDlgSetting)
	{
		m_pDlgSetting->SaveAllConfig();
		m_pDlgSetting = NULL;
	}

	GET_APP()->ExitThenRun();
	OnTopMenuExit();
	return 0;
}
LRESULT CNeMessengerDlg::OnCloseSettingFrame(WPARAM wParam,LPARAM lParam)
{
	m_pDlgSetting = NULL;
	return 0;
}

// 대화하기
void CNeMessengerDlg::OnTopMenuChat()
{
	std::vector<const IGTBuddyUser *> buddyVector;

	m_pFrame->GetSelectedOnlineFavorites(buddyVector);
	GET_APP()->m_pChatDialogManager->CreateBuddyChat(buddyVector);
}

// sms 보내기
void CNeMessengerDlg::OnTopMenuSMS()
{
	std::vector<const IGTBuddyUser *> buddyVector;

	m_pFrame->GetSelectedBuddyItems(buddyVector);
	GET_APP()->m_pSMSDialogManager->CreateBuddyLIstSMS(buddyVector);
}

// 전화걸기
void CNeMessengerDlg::OnTopMenuMakeCall()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	if( GET_APP()->IsAvailableIPT() )
	{
		CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

		if (pManager)
			pManager->ShowDialPad();
	}
}

// 전화받기
void CNeMessengerDlg::OnTopMenuAnswerCall()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	g_pMessengerActor->RequestAnswerCall(g_pMessengerActor->GetUserID(), GetCID());
}

// 전화끊기
void CNeMessengerDlg::OnTopMenuClearConnection()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	if (NMessageBox(this, LoadStringFromResource(IDS_STRING609), _T("Ntalk Biz"), MB_YESNO) == IDYES)	// 다국어
	{
		g_pMessengerActor->RequestHangUp(g_pMessengerActor->GetUserID(), GetCID());
	}
}

// 잠시보류
void CNeMessengerDlg::OnTopMenuHoldCall()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	g_pMessengerActor->RequestHoldCall(g_pMessengerActor->GetUserID(), GetCID());
}

// 잠시보류 해제
void CNeMessengerDlg::OnTopMenuRetrieveCall()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	g_pMessengerActor->RequestResumeCall(g_pMessengerActor->GetUserID(), GetCID());
}

// 착신전환 등록
void CNeMessengerDlg::OnTopMenuForwarding()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	if (GetForwardingStatus() == 0)
	{
		GT_MY_USER_DATA myUserData;
		g_pMessengerActor->GetMyUserInfo(myUserData);

		CSelectTelnoDlg dlg;
		dlg.SetTelNos(myUserData.sMyPage.strExtensionTelNo, myUserData.sMyPage.strIncomeTelNo, myUserData.sMyPage.strCphNo);

        GET_MESSENGER_DLG()->RegisterMfcModalDlg(&dlg);
        int nRet = dlg.DoModal();
        GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&dlg);

		if (nRet == IDOK)
		{
			if(GetDND())
			{
				g_pMessengerActor->RequestSetDND( g_pMessengerActor->GetUserID(), 0);
			}
			m_strRequestedFwdTelNo = dlg.GetForwardingTelNo();
			g_pMessengerActor->RequestCallForwarding( g_pMessengerActor->GetUserID(), 1, m_strRequestedFwdTelNo );
		}
	}
	else
	{
		g_pMessengerActor->RequestCallForwarding( g_pMessengerActor->GetUserID(), 0, _T("") );
	}
}

// 호 전환
void CNeMessengerDlg::OnTopMenuCallTransfer()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	GET_MESSENGER_DLG()->GetWorkGroupController()->OpenAddUserDlg(this, ADD_USER_FROM_TOPMENU_CALLTRANSFER);
}

// 수신차단
void CNeMessengerDlg::OnTopMenuDoNotDisturbTrue()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	SetDND();
}

// 수신차단 해제
void CNeMessengerDlg::OnTopMenuDoNotDisturbFalse()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	SetDND();
}

// 수신차단
void CNeMessengerDlg::SetDND()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	CString strMsg;
	if( GetDND() == 0 )
		strMsg = LoadStringFromResource(IDS_STRING610);
	else
		strMsg = LoadStringFromResource(IDS_STRING611);

	if (NMessageBox(GetParent(), strMsg, _T("Ntalk biz"), MB_YESNO) == IDYES)
	{
		if (GetForwardingStatus())
			g_pMessengerActor->RequestCallForwarding( g_pMessengerActor->GetUserID(), 0, _T("") );
		g_pMessengerActor->RequestSetDND( g_pMessengerActor->GetUserID(), GetDND() == 0 ? 1 : 0 );
	}
}

// 회의통화
void CNeMessengerDlg::OnTopMenuConferenceCall()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	GET_MESSENGER_DLG()->GetWorkGroupController()->OpenAddUserDlg(this, ADD_USER_FROM_CONFERENCECALL);
}

// 쪽지 보내기
void CNeMessengerDlg::OnTopMenuSendMemo()
{
	

	if(GET_MESSENGER_DLG()->GetSafeHwnd())
	{
		std::vector<const IGTBuddyUser* > buddyVector;

		m_pFrame->GetSelectedBuddyItems(buddyVector);
		GET_APP()->m_pSendNoteManager->CreateBuddyListNote(buddyVector);
	}
}

// 조직도 보기
void CNeMessengerDlg::OnTopMenuViewOrganizationChart()
{
	LoadOrganization(SHOW_ORG, this);		
}

// 업무그룹 보기
void CNeMessengerDlg::OnTopMenuViewWorkGroup()
{
	LoadOrganization(SHOW_WORKGROUP, this);	
}

// 대화상대 삭제
void CNeMessengerDlg::OnTopMenuDel()
{
	m_pFrame->RequestDeleteBuddy();
}

// 그룹만들기
void CNeMessengerDlg::OnTopMenuMakeGroup()
{
	m_pFrame->RequestAddGroup();
}

// 그룹 이름 바꾸기
void CNeMessengerDlg::OnTopMenuRenameGroup()
{
	m_pFrame->EditLableOn();
}

// 그룹삭제
void CNeMessengerDlg::OnTopMenuDelGroup()
{
	m_pFrame->RequestDeleteGroup();
}

// 메세지 관리함
void CNeMessengerDlg::OnTopMenuManageMemo()
{
	CString strTicket = CString(g_pMessengerActor->GetMessengerTicket());	
	CString strLang = m_pFrame->GetLanguage();
	
	if (TRUE == CXHyperLink::UseAlreadyOpenedIE(_T("nnote.ncloudbiz.com")))
		return;

	CString strUrl;	
    strUrl.Format(CServerAddrConfig::Instance().GetMessageUrl() , strTicket, strLang);  //NTALK_MESSAGE_URL
	CXHyperLink::GotoURL(strUrl, SW_SHOWNORMAL);
}

// 지난 대화 보기
void CNeMessengerDlg::OnChatHistory()
{
	if(GET_MESSENGER_DLG()->GetSafeHwnd())
	{
		std::vector<const IGTBuddyUser* > selectedBuddys;

		m_pFrame->GetSelectedBuddyItems(selectedBuddys);
		if (selectedBuddys.size()>0)
		{
			std::vector<const IGTBuddyUser *>::iterator buddyIterator =selectedBuddys.begin();
			const IGTBuddyUser *pUser = *buddyIterator;
			ASSERT(pUser != NULL);

				OpenChatHistoryDlg(pUser->GetUserID());
			
		}
	}
}

void CNeMessengerDlg::OpenChatHistoryDlg(CString UserID)
{
	CString strTicket = CString(g_pMessengerActor->GetMessengerTicket());

	CString strUrl;	
    strUrl.Format(CServerAddrConfig::Instance().GetChatHistoryUrl(), strTicket, m_pFrame->GetUserID_Base64(UserID)); //NTALK_CHAT_HISTORY_URL
	CXHyperLink::GotoURL(strUrl, SW_SHOWNORMAL);
}

// 전화 내역
void CNeMessengerDlg::OnTopMenuManageCall()
{
	if( GET_APP()->IsAvailableIPT() )
	{
		if (m_pCallHistoryDlg)
		{
			if (m_pCallHistoryDlg->GetSafeHwnd())
				m_pCallHistoryDlg->SetForegroundWindow();
		}
		else
		{
			m_pCallHistoryDlg = new CCallHistoryDlg(this);
			if (NULL != m_pCallHistoryDlg)
			{
				m_pCallHistoryDlg->Create(CCallHistoryDlg::IDD, CWnd::GetDesktopWindow());
				m_pCallHistoryDlg->ShowWindow(SW_SHOW);
			}
		}
	}
}

// 환경 설정
extern int g_ModalBoxCount;
extern int g_nMessageBoxCount;
extern HWND g_hMessageBox[MAX_MESSAGEBOX_COUNT];
extern CCriticalSection g_csModalBoxCount;

void CNeMessengerDlg::OnTopMenuManageConfig()
{	
	if (m_pDlgSetting==NULL || !IsWindow(m_pDlgSetting->GetHWND()))
	{
		CSingleLock modalBoxCountLock(&g_csModalBoxCount);
		modalBoxCountLock.Lock();
		++g_ModalBoxCount;
		modalBoxCountLock.Unlock();
		m_pDlgSetting = new CSettingFrame;
		m_pDlgSetting->Create(m_hWnd, _T("Setting"), WS_POPUPWINDOW, WS_EX_DLGMODALFRAME, CRect(0,0,445, 422));
		CRect rcWnd(0, 0, 0, 0);
		GetWindowRect(rcWnd);
		m_pDlgSetting->SetWindowPosition(rcWnd);

        GET_MESSENGER_DLG()->RegisterDuiModalWnd(m_pDlgSetting);
        int result = m_pDlgSetting->ShowModal();
        GET_MESSENGER_DLG()->UnRegisterDuiModalWnd(m_pDlgSetting);

		modalBoxCountLock.Lock();
		--g_ModalBoxCount;
		modalBoxCountLock.Unlock();
	}
	SetForegroundWindow();
}

// 상용구 설정
void CNeMessengerDlg::OnTopMenuManageAutoText()
{
	CSingleLock modalBoxCountLock(&g_csModalBoxCount);
	modalBoxCountLock.Lock();
	++g_ModalBoxCount;
	modalBoxCountLock.Unlock();

    GET_MESSENGER_DLG()->RegisterMfcModalDlg(&m_AutoTextConfigDlg);
    int nRet = m_AutoTextConfigDlg.DoModal();
    GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&m_AutoTextConfigDlg);


	modalBoxCountLock.Lock();
	--g_ModalBoxCount;
	modalBoxCountLock.Unlock();
}

// 다운로드 폴더열기
void CNeMessengerDlg::OnTopMenuOpenDownloadFolder()
{
	ShellExecute(0, 0, GET_CONFIG()->GetRecvFolder(), 0, 0, SW_SHOWNORMAL);
}

void CNeMessengerDlg::OnTopMenuImportGroup()
{
	m_pFrame->ImportGroup();
}

// 프로그램 정보
void CNeMessengerDlg::OnTopMenuAbout()
{
	/*
	CAboutDlg dlg;
	CSingleLock modalBoxCountLock(&g_csModalBoxCount);
	modalBoxCountLock.Lock();
	++g_ModalBoxCount;
	modalBoxCountLock.Unlock();

	dlg.DoModal();

	modalBoxCountLock.Lock();
	--g_ModalBoxCount;
	modalBoxCountLock.Unlock();
	*/
	if (m_pAboutWnd==NULL || !IsWindow(m_pAboutWnd->GetHWND()))
	{
		CSingleLock modalBoxCountLock(&g_csModalBoxCount);
		modalBoxCountLock.Lock();
		++g_ModalBoxCount;
		modalBoxCountLock.Unlock();
		m_pAboutWnd = new CAboutWnd;
		m_pAboutWnd->Create(m_hWnd, _T("aboutwnd"), WS_POPUPWINDOW, WS_EX_DLGMODALFRAME, CRect(0,0,270,347));
		m_pAboutWnd->CenterWindow();

        GET_MESSENGER_DLG()->RegisterDuiModalWnd(m_pAboutWnd);
        int nRet = m_pAboutWnd->ShowModal();
        GET_MESSENGER_DLG()->UnRegisterDuiModalWnd(m_pAboutWnd);

		modalBoxCountLock.Lock();
		--g_ModalBoxCount;
		modalBoxCountLock.Unlock();
	}
	
}

// 도움말
void CNeMessengerDlg::OnTopMenuHelpNeMessenger()
{
}


void CNeMessengerDlg::OnTopMenuFavoriteCopy(UINT nCmdID)
{
	m_pFrame->MenuCopyBuddy(nCmdID, ID_TOPMENU_COPYGROUPLIST_START);
}


void CNeMessengerDlg::OnTopMenuFavoriteMove(UINT nCmdID)
{
	m_pFrame->MenuMoveBuddy(nCmdID,ID_TOPMENU_MOVEGROUPLIST_START);
}

LRESULT CNeMessengerDlg::OnDesktopIdle(WPARAM wParam,LPARAM lParam)
{
	if (GET_CONFIG()->GetAutoAwayState() != 1)
		return 0;

	switch(wParam)
	{
	case MONITOR_ID_AWAY:
		{			
			if (IsLogin() && g_stNtalkInfo.eMyStatus == ustONLINE)
			{
				ProcChangeMyStatus(ustAUTOAWAY);
			}
		}
		break;
	case MONITOR_ID_NOT_AWAY:
		{
			if (g_stNtalkInfo.eMyStatus == ustAUTOAWAY)
			{
				ProcChangeMyStatus(ustONLINE);
			}
		}
	}
	
	return 0;
}

LRESULT CNeMessengerDlg::OnTinyServerMessage( WPARAM wParam,LPARAM lParam )
{

	TINY_SERVER_MSG* pMsg = (TINY_SERVER_MSG*)wParam;
	if (pMsg->strMsgType == L"profile")
	{
		if (IsLogin() && (GET_CONFIG()->EnableFunction(_T("UI_03"))) )
		{
			if (!pMsg->strUserID.IsEmpty())
			{
				OnTopMenuMyInfo();
			}
		}
	}
	else if (pMsg->strMsgType == L"note")
	{
		if (!m_bLogin)
		{
			NMessageBox(GetDesktopWindow(), LoadStringFromResource(IDS_STRING153));
			return 0;
		}
		
		if (pMsg->strUserID.IsEmpty())
			return 0;

		CString strReceive = pMsg->strUserID;
		CStringArray arrUsersnData;
		DivideString(strReceive, _T("|"), &arrUsersnData);
		CString strUsers = arrUsersnData.GetAt(0);
		CString strTitle  = arrUsersnData.GetAt(1);
		CString strData  = arrUsersnData.GetAt(2);
		CStringArray arrToUserID;
		int nCount = DivideString(strUsers, _T(","), &arrToUserID);
		std::vector<ReceiverInfo> receiverVector;
		for (int index = 0; index < arrToUserID.GetCount(); index++)
		{

			ReceiverInfo receiverInfo;
			CString strID =arrToUserID.GetAt(index);
			receiverInfo.strID = strID.MakeLower();

			const NE_MEMBER_DATA *data = g_pMessengerActor->GetEmployeeInfo(receiverInfo.strID.c_str());
			if (data)
				receiverInfo.strName =  data->strName.c_str();

			receiverVector.push_back(receiverInfo);
		}

		GET_APP()->m_pSendNoteManager->PreMakeMemoSendDlg(receiverVector,strTitle,strData);

	}
	else if (pMsg->strMsgType == L"chat")
	{
		if (!m_bLogin)
		{
			NMessageBox(GetDesktopWindow(), LoadStringFromResource(IDS_STRING153));
			return 0;
		}

		CString strUsers = pMsg->strUserID.MakeLower();
		std::vector<wstring> vecUsers;
		DivideString(strUsers, _T(","), vecUsers);
		if (vecUsers.size() > MAX_CHAT_USER)
		{
			//GET_APP()->m_pMessageBoxManager->CreateMessageBox(GetDesktopWindow(), LoadStringFromResource(IDS_STRING157));
			NMessageBox(CWnd::GetDesktopWindow(), LoadStringFromResource(IDS_STRING157));
			return FALSE;
		}

		if (vecUsers.size() <= 0)
		{
			//GET_APP()->m_pMessageBoxManager->CreateMessageBox(GetDesktopWindow(), LoadStringFromResource(IDS_STRING230));
			NMessageBox(CWnd::GetDesktopWindow(), LoadStringFromResource(IDS_STRING230));
			return FALSE;
		}

		g_pMessengerActor->RequestGetBuddyStatus(vecUsers);

	}
	
	
	return 0;
}

bool CNeMessengerDlg::IsLogOutMsg(MSG* pMsg)
{
	return (bool)(pMsg->message == WM_LOGOUT);
}

BOOL CNeMessengerDlg::PreTranslateMessage(MSG* pMsg)
{	
	if (pMsg->hwnd != m_hWnd)
	{
		return FALSE;
	}
	if (pMsg->message == WM_CHAR)
	{
		return FALSE;
	}
	else if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE)
		{
			m_pFrame->CheckCloseProfileWindow();
			if (m_pFrame != NULL && IsWindow(m_pFrame->GetHWND()) && m_pFrame->IsShowMainSearchWnd())
			{
				m_pFrame->CloseSearchWnd();
			}
			else
			{
				ShowWindow(SW_HIDE);
			}
			return TRUE;
		}
	
		else if(pMsg->wParam == VK_RETURN)
		{
			if(m_bLogin == FALSE)
			{
				m_LoginDlg.OnBnClickedLoginButton();
			}
			else
			{
				if (m_pFrame!=NULL && m_pFrame->IsFocuseOnSearchEdit())
				{
					m_pFrame->OnSearchUser();
				}
			}
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	else if ((pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4))
	{
		m_pFrame->CheckCloseProfileWindow();
		ShowWindow(SW_HIDE);
		return TRUE;
	}
	else if ( IsCloseMsg(pMsg) == true )
	{
		if(g_ModalBoxCount > 0)
			return FALSE;
		OnOK();
		return TRUE;
	}
	else if(IsLogOutMsg(pMsg))
	{
		LogOut();
	}
	else if (pMsg->message == WM_NCLBUTTONDBLCLK)
	{
		if (pMsg->hwnd != this->GetSafeHwnd() || !IsLogin())
			return TRUE;
		return CSkinDialog::PreTranslateMessage(pMsg);

	}
	/*
	else if( pMsg->message == WM_SYSCOMMAND && pMsg->wParam == SC_CLOSE )
	{
		this->ShowWindow(SW_HIDE);
		return TRUE;
	}
	*/
	
	return CSkinDialog::PreTranslateMessage(pMsg);
}

void CNeMessengerDlg::OnClose()
{
	// TODO: Add your message handler code here and/or call default
	
	ShowWindow(SW_HIDE);
	//__super::OnClose();
}


void CNeMessengerDlg::OnDestroy()
{
	NTALK_LOG->Debug(L"[MAIN] OnDestroy");
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);
	g_pMessengerActor->UnRegisterObserver(this);

	__super::OnDestroy();

	CloseChildAll();

	//핫키 해제
	::UnregisterHotKey(this->GetSafeHwnd(), m_nHotkeyAltMID);

	WTSUnRegisterSessionNotification(GetSafeHwnd());

	
	UnRegisterPeriodicEventThread();
}

LRESULT CNeMessengerDlg::OnTrayChangeStatus(WPARAM wParam,LPARAM lParam)
{
	GTUserStatusType type;

	switch(wParam)
	{
	case 1:
		type = ustONLINE;
		break;
	case 2:
		type = ustOFFLINE;
		LogOut();
		return 0;
	case 3:
		type = ustOUTSIDE;
		break;
	case 4:
		type = ustEAT;
		break;
	case 5:
		type = ustBUSY;
		break;
	case 6:
		type = ustAWAY;
		break;
	default:
		type = ustOFFLINE;
		break;

	}

	//ASSERT(type >= ustONLINE && type <= ustAUTOAWAY);
	//if (type >= ustONLINE && type <= ustAUTOAWAY)
	//{
		ProcChangeMyStatus(type);
	//}
	return 0;
}

LRESULT CNeMessengerDlg::OnNTalkNotifyVersion(WPARAM wParam,LPARAM lParam)
{
	if (m_isCheckingUpdate)
	{
		m_isCheckingUpdate = FALSE;

		BOOL bSameVersion = BOOL(wParam);
		if (bSameVersion)
		{
			NMessageBox(CWnd::GetDesktopWindow(), LoadStringFromResource(IDS_NEWEST_VERSION));
		}
	}
	return 0;
}

void CNeMessengerDlg::OnTraySetting()
{
	OnTopMenuManageConfig();
}

void CNeMessengerDlg::OnTrayLogin()
{
//	GT_FLOG(L"TrayLogin");
	if(m_bLogin == FALSE)
	{
		if(this->IsIconic() == TRUE)
		{
			ShowWindow(SW_RESTORE);						
		}
		else
		{
			SetForegroundWindow();
			ShowWindow(SW_SHOW);		
		}
		
		m_LoginDlg.OnBnClickedLoginButton();		
	}
}

void CNeMessengerDlg::OnUpdate()
{	
	m_isCheckingUpdate = TRUE;

	CString strRootPath;
#ifdef _DEBUG
	strRootPath.AppendFormat(_T("%s\\..\\update\\bin\\Debug\\NtalkbizUpgraderLauncherD.exe"), GetNtalkModulePath());			
#else
	strRootPath.AppendFormat(_T("%s\\Update\\NtalkbizUpgraderLauncher.exe"), GetNtalkModulePath());			
#endif 
	
	
	ShellExecute(NULL, NULL, strRootPath, _T("/M /A"), NULL, SW_SHOWNORMAL);
}

void CNeMessengerDlg::OnTrayLogout()
{
//	GT_FLOG(L"TrayLogout");
	LogOut();
}

void CNeMessengerDlg::OnTrayOpen()
{
	if(IsIconic() == TRUE)
	{
		ShowWindow(SW_RESTORE);
	}
	else
	{
		SetForegroundWindow();
		ShowWindow(SW_SHOW);

	}

	if ( GetStyle() & WS_MINIMIZE )
	{
		ShowWindow( SW_SHOWNOACTIVATE);
		UpdateWindow();
	}

	HWND hWndForeground = ::GetForegroundWindow();
	if(hWndForeground == this->m_hWnd) return;

	DWORD Strange = ::GetWindowThreadProcessId(hWndForeground, NULL);
	DWORD My = ::GetWindowThreadProcessId(this->m_hWnd, NULL);
	::AttachThreadInput(Strange, My, TRUE);
	::SetForegroundWindow(this->m_hWnd);
	::BringWindowToTop(this->m_hWnd);
	::SetFocus(this->m_hWnd);
	::AttachThreadInput(Strange, My, FALSE); 

}

void CNeMessengerDlg::OnTrayExit()
{
	//GET_APP()->m_pChatDialogManager->SetNeedRestoreChatRoomID(true);
	NTALK_LOG->Debug(L"[MAIN] OnTrayExit");

	int Success = GET_APP()->m_pChatDialogManager->RemoveAll();
	if (0 == Success)
	{
		CloseChildAll();
		CSkinDialog::OnOK();

	}
	/*CloseChildAll();
	CSkinDialog::OnOK();*/
}

void CNeMessengerDlg::LoadOrganization(ORGVIEWTYPE eViewType, CWnd *pParent)
{
	if (NULL != m_pWorkGroupController) m_pWorkGroupController->ShowView(eViewType);
}

//////////////////////////////////////////////////프로시저
//로그인 프로시저
bool CNeMessengerDlg::ProcLogin(CString strId, CString strPw)
{
	if (g_stNtalkInfo.strCorp.IsEmpty() == TRUE )
	{
		GET_APP()->m_pMessageBoxManager->CreateMessageBox(this, LoadStringFromResource(IDS_STRING_NEMSGDLG_EMPTYCORP));
		return FALSE;
	}

	if( g_stNtalkInfo.strDomain.IsEmpty() == TRUE )
	{
		GET_APP()->m_pMessageBoxManager->CreateMessageBox(this, LoadStringFromResource(IDS_STRING_NEMSGDLG_EMPTYDOMAIN));
		return FALSE;
	}

	g_stNtalkInfo.strId = strId;
	g_stNtalkInfo.strPassword = strPw;

	CString strLoginID;
	strLoginID.Format(LOGIN_ID_TEXT, g_stNtalkInfo.strCorp, strId);

	// 이전 셋팅을 얻어온다.
	GT_API_ENVIRONMENT_DATA sEnv;
	NeMessengerAPISetting::GetEnvironment(sEnv);

    const CServerAddrConfig& serverCfg = CServerAddrConfig::Instance();
	// 현재의 로그인 서버 정보를 설정한다.
    UINT nRandPort = rand() % serverCfg.GetPortCount();// PORT_COUNT_FROM_10500;
	if( g_stNtalkInfo.strCorp == _T("hanatour") )
	{
        _tcscpy_s(sEnv.sLoginServerAddress.strAddress, 256, serverCfg.GetHanatourServerIp());//  HANATOUR_SERVER_IP);
	}
	else
	{
        _tcscpy_s(sEnv.sLoginServerAddress.strAddress, 256, serverCfg.GetNhnServerIp());// NHN_SERVER_IP);
	}
	
	sEnv.sLoginServerAddress.nPort = serverCfg.GetServerPort() + nRandPort; //SERVER_PORT 

	// API 셋팅을 변경한다.
	NeMessengerAPISetting::SetEnvironment(sEnv);		

	// 로그인 요청	
	if(g_pMessengerActor->RequestLogin(strLoginID, strPw, GetLanguageStringUnicode(), g_stNtalkInfo.strDomain) == false)
	{
		// 로그인요청에 실패
		if( m_bRetryLoginWithInterval != TRUE )
			m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_REQUESTLOGIN));
		m_bLogin = FALSE;
		return FALSE;
	}

	return TRUE;
}

// 톡네임 변경 프로시저
int CNeMessengerDlg::ProcRenameTalkname(CString strTalkname)
{	
	GT_USER_PROFILE_DATA userData;
	g_pMessengerActor->GetMyUserProfile(userData);
	
	if(strTalkname.Compare(userData.strTalkName) != 0)
	{
		userData.strTalkName = strTalkname;

		IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
		pWASActor->RequestSetMyUserProfile(userData);
	}
	return 0;
}


// 그룹이름 변경 프로시저
int CNeMessengerDlg::ProcRenameGroupName(int nCurGroupID, CString strNewGroupname)
{
	CString strMessage;
    strNewGroupname.Trim();
    if (strNewGroupname.IsEmpty())
    {
        strMessage.LoadString(IDS_STRING265);
        GET_APP()->m_pMessageBoxManager->CreateMessageBox(this, strMessage);
        return -1;
    }
	const IGTBuddyGroup* pBuddyGroup = g_pMessengerActor->GetBuddyGroupInfo(strNewGroupname);
	if( pBuddyGroup != NULL )
	{
		strMessage.LoadString(IDS_STRING253);
		GET_APP()->m_pMessageBoxManager->CreateMessageBox(this, strMessage);
		return -1;
	}

	GT_BUDDY_GROUP_UPDATABLE_DATA buddyGroupData;
	buddyGroupData.strName = strNewGroupname;
	if(g_pMessengerActor->RequestUpdateBuddyGroup(nCurGroupID, buddyGroupData) == false)
	{
		NTALK_LOG->Debug(L"[BUDDY] RequestUpdateBuddyGroup(%d) Failed", nCurGroupID);
		GET_APP()->m_pMessageBoxManager->CreateMessageBox(this, LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_REQUESTGROUPRENAME));
	}
	else
		NTALK_LOG->Debug(L"[BUDDY] RequestUpdateBuddyGroup(%d) Succeeded", nCurGroupID);

	return 0;
}

//그룹 정렬 변경 프로시저
bool CNeMessengerDlg::ProcGroupSort(std::vector<GT_BUDDY_GROUP_DATA>& vecGroupData)
{
	bool bRet = true;
	if(g_pMessengerActor->RequestUpdateBuddyGroupSortOrder(vecGroupData) == false)
	{
		ASSERT(FALSE);
	}

	return bRet;
}

// 내상태정보변경 프로시저
bool CNeMessengerDlg::ProcChangeMyStatus(GTUserStatusType type)
{
	/*if (type < ustOFFLINE || type > ustAUTOAWAY)
		return false;*/

	CSingleLock lock(&m_csSetStatus);
	lock.Lock();
	if( lock.IsLocked() )
	{
		g_stNtalkInfo.eMyStatus = type;

		g_pMessengerActor->RequestSetMyStatus(g_stNtalkInfo.eMyStatus);

		lock.Unlock();
	}

	return true;
}

// 사용용량 확인
bool CNeMessengerDlg::ProcTotalUsedCapa()
{	
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	return g_pMessengerActor->GetWASActor()->RequestGetTotalUsedCapa();
}

bool CNeMessengerDlg::ProcListNotice()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	return g_pMessengerActor->GetWASActor()->RequestListNotice();
}

bool CNeMessengerDlg::ProcGetHanatourCount()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	// 권한 검사(3개의 권한이 모두 없으면 API를 호출하지 않는다.
	if (IsNonAuthorizedUser())
		return false;

	// 고객사 요청으로 업무시간(08:30~18:30)에는 15분마다 호출, 그 외는 1시간마다 호출하도록 함
	// 참고로, 이 함수는 Timer 에서 5분마다 호출함
	CTime currentTime = CTime::GetCurrentTime();

	if ((currentTime.GetHour() == 8 && currentTime.GetMinute() >= 30) ||
		(currentTime.GetHour() >= 9 && currentTime.GetHour() <= 17) ||
		(currentTime.GetHour() == 18 && currentTime.GetMinute() <= 30))
	{
		CTimeSpan ts = currentTime - m_lagacyCountLoadTime;
		if (ts.GetTotalMinutes() >= 15)
		{
			g_pMessengerActor->GetWASActor()->RequestGetHanatourCount();
			m_lagacyCountLoadTime = currentTime;
		}
	}
	else	// 업무시간이 아닌 경우
	{
		CTimeSpan ts = currentTime - m_lagacyCountLoadTime;
		if (ts.GetTotalMinutes() >= 60)
		{
			g_pMessengerActor->GetWASActor()->RequestGetHanatourCount();
			m_lagacyCountLoadTime = currentTime;
		}
	}

	return true;
}

bool CNeMessengerDlg::ProcListOutLink()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	return g_pMessengerActor->GetWASActor()->RequestListOutLink();	
}

bool CNeMessengerDlg::ProcRefreshTicket()
{	
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	g_pMessengerActor->RequestRefreshTicket();
	return true;
}

bool CNeMessengerDlg::ProcChatMyRoomList()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);	
	return g_pMessengerActor->GetWASActor()->RequestGetMyRoomList(GetLanguageStringUnicode());
}

bool CNeMessengerDlg::ProcUnreadNoteCnt()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);	
	return g_pMessengerActor->GetWASActor()->RequestUnreadNoteCount();
}

bool CNeMessengerDlg::ProcPhoneCall(CString strUserID, CString strPhoneNum)
{
	// 발신자(나)
	GT_MY_USER_DATA myData;
	g_pMessengerActor->GetMyUserInfo(myData);

	m_sCallData.nCallSeq = 0;
	m_sCallData.strSendUserId = myData.strUserID;
	m_sCallData.strSendTelNo = myData.sMyPage.strExtensionTelNo;

	// 수신자
	m_sCallData.strRecvUserId = strUserID;
	m_sCallData.strRecvTelNo = strPhoneNum;

	return g_pMessengerActor->RequestPhoneCall(g_pMessengerActor->GetUserID(), strPhoneNum);
}

//bool CNeMessengerDlg::ProcPhoneConferenceCall( CString strUserID, CString strPhoneNum )
//{
//	// caller(나)
//	GT_MY_USER_DATA myData;
//	g_pMessengerActor->GetMyUserInfo(myData);
//
//	m_sCallData.nCallSeq = 0;
//	m_sCallData.strSendUserId = myData.strUserID;
//	m_sCallData.strSendTelNo = myData.sMyPage.strExtensionTelNo;
//
//	// callee
//	m_sCallData.strRecvUserId = strUserID;
//	m_sCallData.strRecvTelNo = strPhoneNum;
//	return g_pMessengerActor->RequestConferenceCall(strUserID,  strPhoneNum);
//}

///////////////////////////// IGTMessengerActorEvent
bool CNeMessengerDlg::OnGTMessengerActor_ResponseBuddyAction(IGTMessengerActor *pActor, const GT_BUDDY_RESULT_DATA& sData)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);	
	NTALK_LOG->Debug(L"[BUDDY] Buddy Action = %d, %d, %s", sData.eAction, sData.eError, sData.sBuddyInfo.GetUserID());

	if (NULL == pActor)
		return false;

	switch(sData.eAction)
	{
		case buddyAction_Add:
			if(sData.eError == buddyError_None)
			{
				const IGTBuddyUser* pUser = pActor->GetBuddyInfo(sData.sBuddyInfo.GetUserID(), sData.sBuddyInfo.GetGroupID());
				if (NULL == pUser)
					return FALSE;

				if(m_pFrame)m_pFrame->AddBuddy(pUser);
				if(m_pFrame)m_pFrame->ResortBuddyInGroup(sData.sBuddyInfo.GetGroupID());

				// IPT 프레젠스 요청
				if (GET_APP()->IsAvailableIPT())
				{
					vector<LPCWSTR> vecUser;
					vecUser.push_back(pUser->GetUserID());
					
					g_pMessengerActor->RequestPhoneStatus(g_pMessengerActor->GetUserID(), vecUser);
				}
			}
			else if (sData.eError == buddyError_AlreadyAdded)						
			{
				GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_ALREADYADDEDBUDDY));
				return false;
			}
			else if (sData.eError == buddyError_Max && sData.trid != m_pWorkGroupController->GetBuddyActionTridFromWorkgroupDlg())
			{
				GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING632));		
				return false;
			}
			else	
			{
				GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_REQUESTADDBUDDY));	

				return false;
			}				
			break;
		case buddyAction_Delete:
			if(sData.eError == buddyError_None)
			{	
				if(m_pFrame)m_pFrame->DeleteBuddy(sData.sBuddyInfo.GetUserID(), sData.sBuddyInfo.GetGroupID());
			}
			else
			{

				GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_REQUESTDELBUDDY));
			}
			break;
		case buddyAction_Update:
			const IGTBuddyUser* pUser = pActor->GetBuddyInfo(sData.sBuddyInfo.GetUserID(), sData.sBuddyInfo.GetGroupID());
			if (NULL == pUser)
				return false;

			if (sData.eError == buddyError_None)
			{
				if(m_pFrame)m_pFrame->MoveBuddy(sData.nFromGroupID, pUser);
				if(m_pFrame)m_pFrame->ResortBuddyInGroup(pUser->GetGroupID());
			}
			else if(sData.eError == wasError_DuplicateBuddy)
			{
				GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_ALREADYADDEDBUDDY));
			}
			else
			{
				GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_REQUESTMOVEBUDDY));
			}
			break;
	}
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	return true;
}

bool CNeMessengerDlg::OnGTMessengerActor_UpdateBuddyStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID, int nTypeBits)
{
	TRACE(TEXT("%s %d, strBuddyID=%s, nTypeBits=%d\n"), TEXT(__FUNCTION__), __LINE__, strBuddyID, nTypeBits);

	if (IsAvailableUpdateStatus())
	{
		if(m_pFrame)
		{
			m_pFrame->UpdateStatus(pActor, strBuddyID);
		}
		CString strDbg = _T("");
		strDbg.Format(_T("[BUDDY] UpdateBuddyStatus--- strBuddyID(%s): status (%d)"), strBuddyID, pActor->GetBuddyInfo(strBuddyID)->GetStatus());	
		NTALK_LOG->Debug(strDbg);

		if( nTypeBits & buutLogin )
		{
			CString strMsg = _T("");
			strMsg.Format(LoadStringFromResource(IDS_STRING_NEMSGDLG_FORMAT_BUDDYLOGIN), pActor->GetBuddyInfo(strBuddyID)->GetName());	

			if(GET_CONFIG()->GetFavoriteTray() == 1)
			{
				TRAYPOPUP(TDT_LOGIN, strBuddyID, strMsg, this, WM_CLICKBUDDYONLINEPOPUP, (PVOID)pActor->GetBuddyInfo(strBuddyID)->GetID());
			}
		}
	}

	GET_APP()->m_pChatDialogManager->UpdateBuddyStatus(strBuddyID, nTypeBits);

	return false;
}

bool CNeMessengerDlg::OnGTMessengerActor_UpdateNotBuddyUserStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID, int nUserStatus, LPCWSTR strNick, int nIPTStatus, int nFlag)
{
	CString strDbg = _T("");
	strDbg.Format(_T("[BUDDY] UpdateNotBuddyStatus strBuddyID(%s): status (%d)"), strBuddyID, nUserStatus);	
	NTALK_LOG->Debug(strDbg);

	if (m_pFrame !=NULL && IsAvailableUpdateStatus())
	{
		m_pFrame->UpdateStatus(pActor, strBuddyID);
	}

	GET_APP()->m_pChatDialogManager->UpdateNotBuddyStatus(strBuddyID, nUserStatus, strNick, nIPTStatus, nFlag);

	return true;
}

bool CNeMessengerDlg::OnGTMessengerActor_ResponseBuddyGroupAction(IGTMessengerActor *pActor, const GT_BUDDY_GROUP_RESULT_DATA& sData, GTBuddyAddGroupType addGroupType)
{	
	NTALK_LOG->Debug(L"[BUDDY] ResponseBuddyGroupAction, %d, %d, %d", sData.eAction, sData.eError, (int)addGroupType);
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	switch(sData.eAction)
	{
		case buddyGroupAction_Add:
			if (sData.eError == buddyGroupError_None)
			{
				const IGTBuddyGroup* pBuddyGroup = pActor->GetBuddyGroupInfo(sData.nGroupID);
				
				if(m_pFrame)m_pFrame->AddGroup(pBuddyGroup, addGroupType == buddyGroupAction_Favorite);
				if(m_pFrame)::PostMessage(m_pFrame->GetSafeHwnd(), WM_USER + 574, 0, 0);
				return true;
			}
			else
			{
				GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_ADDGROUP));
			}

			break;
		case buddyGroupAction_Update: //수정
			{
				if(sData.eError == buddyGroupError_None)
				{		
					const IGTBuddyGroup* pBuddyGroup = pActor->GetBuddyGroupInfo(sData.nGroupID);
					if(m_pFrame)m_pFrame->UpdateGroupName(pBuddyGroup);
				}
				else if(sData.eError == buddyGroupError_AlreadyExist)
				{
					GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_ALREADYADDEDGROUP));
					if(m_pFrame)m_pFrame->EditLableOn();
				}			
				else
				{
					GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_RENAMEGROUP));
				}
			}
			break;
		case buddyGroupAction_Delete:	
			if(sData.eError == buddyGroupError_None)
			{	
				if(m_pFrame)m_pFrame->DeleteGroup(sData.nGroupID);
			}
			else
			{
				GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_DELGROUP));
			}
			break;
		case buddyGroupAction_Move:
			ASSERT(FALSE);
			break;
		case buddyGroupAction_SortUpdate:
			if(m_pFrame)m_pFrame->FavoriteGroupResort();
			break;

	}
	if(m_pFrame)m_pFrame->RedrawGroup();

	return true;	
}
bool CNeMessengerDlg::OnGTMessengerActor_ResponseUpdateGroupOrder(IGTMessengerActor *pActor, trid_t trid,vector<GT_BUDDY_GROUP_DATA> &vecBuddyGroupData)
{
	//AfxMessageBox(L"Hell");
	if(m_pFrame)m_pFrame->FavoriteGroupResort();
	return true;
}


// 내 상태 정보 이벤트
bool CNeMessengerDlg::OnGTMessengerActor_UpdateMyStatus(IGTMessengerActor *pActor, 
														BYTE flag,
														GTUserStatusType presence,
														NTIPTStatusType iptPrev,
														NTIPTStatusType iptCur)
{
	NTALK_LOG->Debug(L"[MAIN] UpdateMyStatus, %d, %d, %d, %d", flag, presence, iptPrev, iptCur);

	if (flag & NOTIFY_FLAG_PRESENCE)
	{
		if(m_pFrame)m_pFrame->UpdateInfoAboutMeStatus(presence);

		if (FALSE == m_TrayIcon.SetIcon(GET_APP()->GetMyPresenceTrayIconResourceID(presence)))
		{
			m_TrayIcon.AddToTray();
			m_TrayIcon.SetIcon(GET_APP()->GetMyPresenceTrayIconResourceID(presence));
		}

		// 조직도가 띄워져 있을 경우 내 상태를 업데이트 해준다.
		if (NULL != m_pWorkGroupController) 
		{
			if(m_pFrame)
				m_pWorkGroupController->ChangeMyStatus(m_pFrame->GetMyStatus());
		}

		// 대화창의 내 상태 업데이트
		GET_APP()->m_pChatDialogManager->UpdateMyStatus(NOTIFY_FLAG_PRESENCE, presence, _T(""), iptstIDLE);
	}

	if( flag & NOTIFY_FLAG_IPT )
	{
		if (iptCur != iptstNA)
		{
			if (iptPrev == itpstALERTING)
			{
				KILLALLIPTTTRAYPOPUP();
			}
		}
		if( m_bRequestPhoneStatus != TRUE && iptCur != iptstNA )
		{
			if (iptPrev == itpstALERTING)
			{
				KILLALLIPTTTRAYPOPUP();
			}
			GET_APP()->EnableIPT();
			m_bRequestPhoneStatus = TRUE;

			g_pMessengerActor->RequestCallForwardingInfo(g_pMessengerActor->GetUserID());
			g_pMessengerActor->RequestDndStatusInfo(g_pMessengerActor->GetUserID());

			vector<LPCWSTR> vecUser;
			size_t nBuddyCount = g_pMessengerActor->GetBuddyCount();
			for (unsigned int index = 0; index < nBuddyCount; index++)
			{
				const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(index);

				if( find( vecUser.begin(), vecUser.end(), pUser->GetUserID()) != vecUser.end() )
					continue;
				vecUser.push_back(pUser->GetUserID());
			}

			g_pMessengerActor->RequestPhoneStatus(g_pMessengerActor->GetUserID(), vecUser);
		}

		CDialPadManager* pManager = CDialPadManager::GetDialpadManager();
	
		if (pManager)
			pManager->UpdateMyIptStatus(iptCur);

		// 대화창의 내 상태 업데이트
		GET_APP()->m_pChatDialogManager->UpdateMyStatus(NOTIFY_FLAG_IPT, ustONLINE, _T(""), iptCur);

		if(m_pFrame)m_pFrame->UpdateInfoAboutIPTStatus(); //NTIPTStatusType iptCur
		
		if( GetHold() == 1 && (iptCur == iptstACTIVE || iptCur == iptstIDLE) )
			SetHold(0);

		if( iptCur == iptstIDLE || iptCur == iptstDND ) // 대기 및 차단 상태에서 통화 종료 후 처리
		{
			if( iptPrev == iptstACTIVE  || iptPrev == itpstALERTING )	// 전화 통화가 완료된 경우(iptstACTIVE -> iptstIDLE)
			{
				// 통화 종료시간 설정
				if( iptPrev == iptstACTIVE )	// itpstALERTING 은 부재중 전화로 처리(종료시간을 넣지 않아야 부재중 전화로 처리됨)
				{
					m_sCallData.nEndYmdt = ::_time32(NULL);
					g_pMessengerActor->GetWASActor()->RequestSetCallInfo(m_sCallData);
				}

				// DialPadDlg 종료
				if (pManager)
					pManager->DeleteDialPad();
			}
		}
		else if (iptCur == iptstACTIVE)
		{
			if (pManager)
				pManager->UpdateCallStatus(iptstACTIVE);
		}
	}

	return false;
}

// 내 닉네임 정보 이벤트
bool CNeMessengerDlg::OnGTMessengerActor_UpdateMyTalkName(IGTMessengerActor *pActor, LPCWSTR strTalkName)
{	
	NTALK_LOG->Debug(L"[MAIN] UpdateMyTalkName = %s", strTalkName);
	GET_CONFIG()->SetNickName(strTalkName);
	
	UpdateData(FALSE);

	if(m_pFrame)
		m_pFrame->UpdateInfoAboutMeNickName(strTalkName);

	return false;
}

// 대화방초대알림
bool CNeMessengerDlg::OnGTMessengerActor_NotifyRecvChatInvite(IGTMessengerActor *pActor, const GT_MEMO_DATA& sData)
{
	CString strMsg, strID, strName, strNickName, strServerAddress;
	int nPort = 0;
	int nRoomNo = 0;
	int nRoomType = 0; 
	
	vector<CString> vecToken; // 0:id, 1:name, 2:nickname, 3:room id, 4:srv address, 5: srv port, 6: 1:일대일, 10:그룹
	strMsg = sData.strMessage;
	int nCount = 0;

	nCount = SplitString(strMsg, _T('|'), vecToken);
	if (nCount != 7)
	{
		return false;
	}
	
	// dev22@nts.nhncorp|DEV|48516061|10.98.143.36|10600|1
	// strID|strNickName|strRoomID|strSrvAddress|strPort|nRoomType	
	strID = vecToken[0];
	strName = vecToken[1];
	strNickName = vecToken[2];
	nRoomNo = _wtoi(vecToken[3]);
	strServerAddress = vecToken[4];
	nPort = _wtoi(vecToken[5]);
	nRoomType = _wtoi(vecToken[6]);	

	CChatUser *pChatUser = new CChatUser;
	if (NULL == pChatUser)
		return false;

	NTALK_LOG->Debug(L"[CHAT] ROOM_INVITE: %d:%s:%s:PC:%s:%d:%d", nRoomNo, strID, strName, strServerAddress, nPort, nRoomType);

	pChatUser->SetID(strID);
	pChatUser->SetName(strName);
	pChatUser->SetNickName(strNickName);
	pChatUser->SetStatus(ustONLINE);
	pChatUser->SetInviteStatus(TRUE);
	
	GET_APP()->m_pChatDialogManager->CreateInvitedChat(pChatUser, strServerAddress, nPort, nRoomNo, nRoomType);

	return false;
}

// 시스템 공지사항
bool CNeMessengerDlg::OnGTMessengerActor_NotifySystemMessage(IGTMessengerActor *pActor, const ChangeNoticePushData &chageNotice)
{	
	
	GET_APP()->m_pChangeNoticePushController->Clear();
	GET_APP()->m_pChangeNoticePushController->SetNoticeData(chageNotice);
	//BOOL bExposeDomain = GET_APP()->m_pChangeNoticePushController->IsExposeDomain(chageNotice, g_stNtalkInfo.strCorp);
	//if (bExposeDomain && GET_APP()->m_pChangeNoticePushController->IsNewNotice())
	//{
	//	GET_APP()->m_pChangeNoticeDialogManager->CreateNoticeDlg(GET_APP()->m_pChangeNoticePushController);
	//}
	//
	return false;
}

// 즐겨찾기 그룹 정렬
//bool CNeMessengerDlg::OnGTMessengerActor_ResponseUpdateGroupOrder( IGTMessengerActor *pActor, trid_t trid, vector<GT_BUDDY_GROUP_DATA> &vecBuddyGroupData)
//{
//	// TODO: 성공 여부 판단 후 그룹 재정렬하여 그림
//
//	return false;
//}

///////////////////////////////////////////////////////////////////////////////
// IPT Event Handler
///////////////////////////////////////////////////////////////////////////////

// 수신 전화
bool CNeMessengerDlg::OnGTMessengerActor_NotifyIPTCallInfo( IGTMessengerActor *pActor, LPCWSTR strUserID, LPCWSTR strTelNo, LPCWSTR strCID )
{
	NTALK_LOG->Debug(L"[IPT] NotifyIPTCallInfo = %s %s %s", strUserID, strTelNo, strCID);
	if( GET_APP()->IsAvailableIPT() )
	{
		// 전화 수신 알림 다이얼로그
		//if (m_pCallerInfoDlg)
		//{
		//	CloseCallerInfoDlg();
		//}

		//m_pCallerInfoDlg = new CCallerInfoDlg(strUserID, strTelNo, this);

		//if (m_pCallerInfoDlg)
		//{
		//	m_pCallerInfoDlg->Create(CCallerInfoDlg::IDD, CWnd::GetDesktopWindow());
		//	m_pCallerInfoDlg->ShowWindow(SW_SHOW);
		//	m_pCallerInfoDlg->SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
		//	m_pCallerInfoDlg->SetForegroundWindow();
		//}

		// 전화 수신 알림 슬라이드
		CString strCallerID(strUserID);
		if( strCallerID.IsEmpty() || strCallerID == _T("외부전화"))
		{
			m_searchParam.strSearchText = strTelNo;
			m_searchParam.strFunction = GET_CONFIG()->GetFunctionList();
			CString strLangCo = GetLanguageStringUnicode();
			m_searchParam.strLangCode = strLangCo;
			m_searchParam.strDeptId = L"";
			trid_t trid;
			
			g_pMessengerActor->GetWASActor()->RequestNameSearchList(m_searchParam, &trid);
			m_tridMapIPTSearch.insert(make_pair(trid, strTelNo));

		}
		else
		{
			g_pMessengerActor->GetWASActor()->RequestEmplyeeInfo(strUserID, GetLanguageStringUnicode(), reitSingleTrans, &m_tridCallerInfo);
		}
	
		SetCID(strCID);

		GT_MY_USER_DATA myData;
		g_pMessengerActor->GetMyUserInfo(myData);

		// 수신자(나)
		m_sCallData.strRecvUserId = myData.strUserID;
		m_sCallData.strRecvTelNo = myData.sMyPage.strExtensionTelNo;

		// 발신자
		m_sCallData.strSendUserId = strUserID;
		m_sCallData.strSendTelNo = strTelNo;

		m_sCallData.nCallSeq = 0;
		m_sCallData.nStartYmdt = ::_time32(NULL);
		m_sCallData.nEndYmdt = 0;

		// 수신 전화 내역 추가
		g_pMessengerActor->GetWASActor()->RequestSetCallInfo(m_sCallData);

		// CCallerInfoDlg에서 '전화받기' 를 누르면 OnTopMenuAnswerCall()을 호출하므로 여기서는 그냥 리턴한다.
	}

	return false;
}

bool CNeMessengerDlg::OnGTMessengerActor_ResponsePhoneCall( IGTMessengerActor *pActor, BYTE result, LPCWSTR strCID )
{
	NTALK_LOG->Debug(L"[IPT] ResponsePhoneCall= %d %s",  (int)result, strCID);
	if( GET_APP()->IsAvailableIPT() )
	{
		CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

		if( result == IPT_RET_FALSE )
		{
			//AfxMessageBox(LoadStringFromResource(IDS_STRING591));
			NMessageBox(this, LoadStringFromResource(IDS_STRING591));

			if (pManager)
				pManager->UpdateCallStatus(iptstIDLE);
		}
		else
		{
			if (pManager)
				pManager->UpdateCallStatus(itpstALERTING);

			SetCID(strCID);

			m_sCallData.nCallSeq = 0;

			// 통화 시간
			m_sCallData.nStartYmdt = ::_time32(NULL);
			m_sCallData.nEndYmdt = ::_time32(NULL);

			// 발신 통화 내역 추가
			g_pMessengerActor->GetWASActor()->RequestSetCallInfo(m_sCallData);
		}
	}

	return true;
}

bool CNeMessengerDlg::OnGTMessengerActor_ResponseForwardingInfo(IGTMessengerActor *pActor, BYTE ret, BYTE act, LPCWSTR strTelNo)
{
	NTALK_LOG->Debug(L"[IPT] ResponseForwardingInfo= %d, %d, %s",  (int)ret, (int)act, strTelNo);
	if( GET_APP()->IsAvailableIPT() )
	{
		if( ret == IPT_RET_FALSE )
			;//AfxMessageBox(_T("착신전화 정보 요청에 실패하였습니다."));	// 타이머로 잠시 후 다시 시도하도록 수정 필요
		else
			SetForwardingInfo(act, strTelNo);
	}
	if(m_pFrame)m_pFrame->UpdateInfoAboutIPTStatus(); 
	return true;
}

bool CNeMessengerDlg::OnGTMessengerActor_ResponseIptResult(IGTMessengerActor *pActor, BYTE ret, UINT cmd)
{
	if( GET_APP()->IsAvailableIPT() != TRUE )
		return true;

	NTALK_LOG->Debug(L"[IPT] ResponseIptResult= %d, %d",  (int)ret, (int)cmd);
	
	switch( cmd )
	{
	case 0x8403:
		if( ret == IPT_RET_FALSE )
			NMessageBox(this, LoadStringFromResource(IDS_STRING593));
		else	// 전화끊기 성공
		{
			CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

			if (pManager)
				pManager->UpdateCallStatus(iptstIDLE);
		}

		break;
	case 0x8404:
		if( ret == IPT_RET_FALSE )
		{
			if( GetForwardingStatus() == 0 )
				NMessageBox(this, LoadStringFromResource(IDS_STRING594));
			else
				NMessageBox(this, LoadStringFromResource(IDS_STRING595));
		}
		else
		{
			if (GetForwardingStatus() == 0 && !m_strRequestedFwdTelNo.IsEmpty())
			{
				SetForwardingInfo(1, m_strRequestedFwdTelNo);
			}
			else
			{
				SetForwardingStatus(0);
			}
		}
		
		break;
	case 0x8406:
		if( ret == IPT_RET_FALSE )
			NMessageBox(this, LoadStringFromResource(IDS_STRING596));
		break;
	case 0x8408:
		if( ret == IPT_RET_FALSE )
			NMessageBox(this, LoadStringFromResource(IDS_STRING597));
		break;
	case 0x8409:
		if( ret == IPT_RET_FALSE )
			NMessageBox(this, LoadStringFromResource(IDS_STRING598));
		else
		{
			SetDND(GetDND() == 1 ? 0 : 1);

		}
		break;
	case 0x840A:
		if( ret == IPT_RET_FALSE )
			NMessageBox(this, LoadStringFromResource(IDS_STRING601));
		break;
	case 0x840C:
		if( ret == IPT_RET_FALSE )
			NMessageBox(this, LoadStringFromResource(IDS_STRING602));
		break;
	case 0x840B:
		if( ret == IPT_RET_FALSE )
			NMessageBox(this, LoadStringFromResource(IDS_STRING603));
		break;
	case 0x840D:
		if( ret == IPT_RET_FALSE )
			NMessageBox(this, LoadStringFromResource(IDS_STRING604));
		else
		{
			SetHold(GetHold() == 1 ? 0 : 1);
		}
		
		break;
	case 0x840E:
		if( ret == IPT_RET_FALSE )
			NMessageBox(this, LoadStringFromResource(IDS_STRING605));
		else
		{
			SetHold(GetHold() == 1 ? 0 : 1);
		}
		break;
	}
	if(m_pFrame)m_pFrame->UpdateInfoAboutIPTStatus(); 

	return true;
}

bool CNeMessengerDlg::OnGTMessengerActor_ResponseDndInfo(IGTMessengerActor *pActor, BYTE ret, BYTE act)
{
	NTALK_LOG->Debug(L"[IPT] ResponseDndInfo= %d, %d",  (int)ret, (int)act);
	if( GET_APP()->IsAvailableIPT() )
	{
		if( ret == IPT_RET_FALSE )
			;//AfxMessageBox(_T("착신거부 설정 정보 요청에 실패하였습니다."));		// 타이머로 잠시 후 다시 시도하도록 수정 필요
		else
			SetDND(act);
	}

	return true;
}

bool CNeMessengerDlg::OnGTMessengerActor_ResponseRefreshWorkStatus( IGTMessengerActor *pActor, trid_t trid, vector<GT_BUDDY_WORK_STATUS_DATA> &vecWorkStatusData )
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	vector<GT_BUDDY_WORK_STATUS_DATA>::const_iterator workStatusIter = vecWorkStatusData.begin();
	for (; workStatusIter != vecWorkStatusData.end(); workStatusIter++)
	{
		if (IsAvailableUpdateStatus())
		{
			if (NULL != m_pFrame && NULL != m_pFrame->GetFavoriteTreeCtrl()/*GetFavoriteTreeCtrlHwnd()*/)
				m_pFrame->UpdateStatus(pActor, workStatusIter->strid.c_str());
		}
	}
	return true;
}



///////////////////////////////////////////////////////////////////////////////
// WAS Event Handler
///////////////////////////////////////////////////////////////////////////////
bool CNeMessengerDlg::OnGTWASActor_ResponseSetUserProfile(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_USER_PROFILE_DATA &sInfo)
{
	OutputDebugString(_T("\r\n##### OnGTWASActor_ResponseSetUserProfile #####\r\n"));

	if(eErrorCode != wasError_None)
	{
		GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_RENAMETALKNAME));		
		if(m_pFrame)m_pFrame->SetEditNickName(TRUE);
		return false;
	}
	
	GET_CONFIG()->SetNickName(sInfo.strTalkName);	
	
	UpdateData(FALSE);

	if(m_pFrame)m_pFrame->UpdateInfoAboutMeNickName(sInfo.strTalkName);

	return false;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseCheckUserIdentify(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_CHECK_USER_IDENTITY_ERROR_DATA &sInfo)
{
	if (eErrorCode != wasError_None)
		return false;
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	GET_CONFIG()->SetNickName(myUserData.sMyPage.strTalkName);

	return false;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseGetTotalUsedCapa(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_GET_TOTAL_USED_CAPA_DATA &sData)
{
	CString strDbg;
	if(eErrorCode == wasError_None)
	{		
		if(m_pFrame)m_pFrame->UpdateInfoVolume(sData.nTotalUsedCapa, sData.nLimitedCapa);
	}
	else
	{		
		OutputDebugString(_T("\r\n##### [OnGTWASActor_ResponseGetTotalUsedCapa] error #####"));
	}

	return false;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID)
{
	if (eErrorCode != wasError_None)
		return false;
	//test code,should remove;
	//const NE_MEMBER_DATA &sMemberInfo = list.pList[0];
	//TRAYPOPUP_IPT(TDT_IPT_EMPLYEE_INFO,sMemberInfo.strUserId.c_str(), sMemberInfo.strName.c_str(), sMemberInfo.strExtesion.c_str(), sMemberInfo.strJobPos.c_str(), sMemberInfo.strJobDuty.c_str(), sMemberInfo.strDept.c_str(), this, NULL,NULL);
 //   //test code,should remove;
	if(NULL != m_pFrame && trid.GetID() == m_pFrame->GetTridID())		
	{		
		OutputDebugString(_T("\r\n"));
		for(size_t i = 0; i < list.nSize; i++)
		{
			const NE_MEMBER_DATA &sMemberInfo  = list.pList[i];
			CString strDbg;
			strDbg.Format(_T("%s\r\n"), sMemberInfo.strUserId.c_str());
			OutputDebugString(strDbg);
		}
	}
	else if(trid == m_tridCallerInfo)
	{
		for (size_t i = 0; i < list.nSize; i++) 
		{
			const NE_MEMBER_DATA &sMemberInfo = list.pList[i];

			if (sMemberInfo.strUserId.c_str() != m_sCallData.strSendUserId)
            {
				continue; 
            }
			TRAYPOPUP_IPT(TDT_IPT_EMPLYEE_INFO,sMemberInfo.strUserId.c_str(), sMemberInfo.strName.c_str(), sMemberInfo.strExtesion.c_str(), sMemberInfo.strJobPos.c_str(), sMemberInfo.strJobDuty.c_str(), sMemberInfo.strDept.c_str(), this, NULL,NULL);

			/*CString strMsg;
			strMsg.Format(_T("%s %s"), sMemberInfo.strName.c_str() , LoadStringFromResource(IDS_STRING586));
			
			
			TRAYPOPUP(TDT_IM_CHAT, "", strMsg, this, NULL, 0);
			*/
		}

	}

	return true;
}

CString CNeMessengerDlg::GetLoginErrorMessage(GT_LOGIN_ERROR_DATA sError)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	CString strResult;

	CString strErrorSubject;
	CString strErrorContent;
	CString strErrorDetail;
	CString strErrorTemp;

	switch(sError.eErrorCode)
	{
	case lirtServerLoginFail:
		{
			////////////////////////////////////////////////////
			strErrorSubject = _T("서버 로그인 실패");
			////////////////////////////////////////////////////

			switch(sError.errorCode_Server)
			{
			case loginServerError_ConnectFailed:	strErrorContent = _T("서버 연결 실패"); break;
			case loginServerError_InvalidUserID:	strErrorContent = _T("사용자 ID가 인증서버에 존재하지 않음!"); break;
			case loginServerError_InvalidProtocol:	strErrorContent = _T("프로토콜이 클라이언트<->서버가 서로 틀림"); break;
			case loginServerError_InvalidPassword:	strErrorContent = _T("비밀번호가 틀렸을 경우"); break;
			case loginServerError_InvalidTicket:	strErrorContent = _T("유효하지 않은 인증값(쿠키, 티켓)일 경우"); break;
			case loginServerError_NeedIdentify:		strErrorContent = _T("주민등록 번호 인증이 필요한 경우"); break;
			case loginServerError_ServerDown:		strErrorContent = _T("서버 다운일 경우"); break;
			case loginServerError_ServerDataError:	strErrorContent = _T("서버 내부 데이터 오류"); break;
			case loginServerError_ETC_Internal:		strErrorContent = _T("CoreDLL 내부에서 발생한 기타 에러값"); break;
			case loginServerError_ETC_Server:		strErrorContent = _T("인증서버 별로 에러가 다양할 수 있음. 서버로부터 받은 에러 메시지 확인 필요"); break;
			case loginServerError_Unknown_Internal:	strErrorContent = _T("CoreDLL 내부에서 발생한 정의되지 않은 에러값."); break;
			case loginServerError_Unknown_Server:	strErrorContent = _T("인증 서버 처리 과정에서 발생한 정의되지 않은 에러값."); break;
			}																  

			// nNpMsgrCode => INpMsgr.h 참조            : RC_XXX
			// nErrorCode  => NpMsgrProtocolCode.h 참조 : MSNG_ERR_XXX

			strErrorTemp.Format(_T("▶Server Error : %s"), sError.strErrorMsgFromServer );
			strErrorDetail += strErrorTemp + _T("\n");
			strErrorTemp.Format(_T("▶Server Link URL : [%s] [%s]"), sError.strLinkNameFromServer, sError.strLinkURLFromServer ); 
			strErrorDetail += strErrorTemp + _T("\n");
			strErrorTemp.Format(_T("▶Module Error : NpMsgrCode = 0x%x / ErrorCode = 0x%x"), sError.nNpMsgrCode, sError.nNpMsgrDetailErrorCode);
			strErrorDetail += strErrorTemp + _T("\n");
			strErrorTemp.Format(_T("▶Raw Error : %s"), sError.strRawDebugMsg);
			strErrorDetail += strErrorTemp + _T("\n");
			strErrorTemp.Format(_T("▶Debug Error : %s"), sError.strDebugMsg);
			strErrorDetail += strErrorTemp + _T("\n");
		}
		break;
	case lirtP2PInitFail:	
		////////////////////////////////////////////////////
		strErrorSubject = _T("P2P 초기화 실패");
		////////////////////////////////////////////////////

		switch(sError.errorCode_P2PInit)
		{
		case p2pError_Common:					strErrorContent = _T("일반적인 P2P 초기화 실패"); break;
		case p2pError_LowDirectXVersion:		strErrorContent = _T("DirectX 버전 낮음"); break;
		case p2pError_NoNpMsgr:					strErrorContent = _T("NpMsgr 모듈 초기화 실패"); break;
		}																  

		strErrorDetail = sError.strDebugMsg;
		break;
	case lirtWAS_MyPageFail:
	case lirtWAS_BuddyListFail:
	case lirtWAS_BuddyGroupFail:
		////////////////////////////////////////////////////
		if(sError.eErrorCode == lirtWAS_MyPageFail)
			strErrorSubject = _T("WAS-MyPage 실패");
		else if(sError.eErrorCode == lirtWAS_BuddyListFail)
			strErrorSubject = _T("WAS-버디리스트 실패");
		else if(sError.eErrorCode == lirtWAS_BuddyGroupFail)
			strErrorSubject = _T("WAS-그룹리스트 실패");
		////////////////////////////////////////////////////

		switch(sError.errorCode_WAS)
		{
		case wasError_NotRequest:				strErrorContent = _T("WAS 요청조차 하지 않은 경우"); break;
		case wasError_InvalidParameter:			strErrorContent = _T("WAS 요청 파라미터가 잘못된 경우"); break;
		case wasError_Timeout:					strErrorContent = _T("요청 타임아웃"); break;
		case wasError_Auth:						strErrorContent = _T("인증에러"); break; 
		case wasError_ServerDown:				strErrorContent = _T("서버 다운"); break;
		case wasError_Protocol:					strErrorContent = _T("파싱 에러"); break;
		case wasError_Internal:					strErrorContent = _T("내부 에러"); break;
		case wasError_TabooWord:				strErrorContent = _T("금칙어 에러"); break;
		case wasError_PenaltyUser:				strErrorContent = _T("징계받은 유저"); break;
		case wasError_Max:						strErrorContent = _T("MAX 오류"); break;
		case wasError_DB:						strErrorContent = _T("데이터베이스 오류"); break;
		case wasError_NotFound:					strErrorContent = _T("타겟이 존재하지 않음"); break;
		case wasError_NotAffectedRow:			strErrorContent = _T("요청한 값이 동일하여 DB 변경이 되지 않은 경우"); break;
		case wasError_Etc:						strErrorContent = _T("기타 에러"); break;
		}

		strErrorDetail = sError.strDebugMsg;
	}

	strResult.Format(
	_T("[로그인 에러 리포트]")
	_T("\n")
	_T("\n")
	_T("에러 종류 : %s")
	_T("\n")
	_T("\n")
	_T("에러 내용 : %s")
	_T("\n")
	_T("\n")
	_T("에러 상세 : \n%s")
	, strErrorSubject, strErrorContent, strErrorDetail);

	return strResult;
}

LPCTSTR CNeMessengerDlg::_GetActorStateString(GTMessengerActorState state)
{
    switch (state)
    {
        HANDLE_CASE_RETURN_STRING(masInit);
        HANDLE_CASE_RETURN_STRING(masLoginReady);
        HANDLE_CASE_RETURN_STRING(masConnecting);
        HANDLE_CASE_RETURN_STRING(masReceivingMyPage);
        HANDLE_CASE_RETURN_STRING(masReceivingBuddyInfo);
        HANDLE_CASE_RETURN_STRING(masReceivingBuddyGroup);
        HANDLE_CASE_RETURN_STRING(masReceivingMobileBlockList);
        HANDLE_CASE_RETURN_STRING(masLoginOK);
        HANDLE_CASE_RETURN_STRING(masLoginFailed);
        HANDLE_CASE_RETURN_STRING(masDisconnected);
        HANDLE_CASE_RETURN_STRING(masLogoutReady);
        HANDLE_CASE_RETURN_STRING(masLogoutProgress);
        HANDLE_CASE_RETURN_STRING(masLogoutOK);
        HANDLE_CASE_RETURN_STRING(masReloginReady);
        HANDLE_CASE_RETURN_STRING(masReloginOK);
        HANDLE_CASE_RETURN_STRING(masReloginFailed);
        HANDLE_CASE_RETURN_STRING(masFreshTicketFailed);
        HANDLE_CASE_RETURN_STRING(masNetNotAvailable);
    default:
        ASSERT(FALSE && TEXT("Unknown state"));
        return _T("Unknown");
    }
}

///////////////////////////////////////
// IGTMessengerActorEvent
bool CNeMessengerDlg::OnGTMessengerActor_UpdateState(IGTMessengerActor *pActor, GTMessengerActorState state)
{
	CString strDbg;
	strDbg.Format(_T("########## [OnGTMessengerActor_UpdateState] state : %d(%s) ############\r\n"), state, _GetActorStateString(state));
	NTALK_LOG->Debug(_T("[LOGIN] UpdateLoginState : %d(%s)"), (int)state, _GetActorStateString(state));
	OutputDebugString(strDbg);

	switch(state)
	{
	case masReloginReady:
		//m_MainDlg.InitFavoriteList();
		break;
	case masLoginOK: //로그인 성공(7)
	case masReloginOK:
		{
			//SendNote Dialog 미리 준비
			//GET_APP()->m_pSendNoteManager->InitSendNoteDialogPool();
			m_LoginDlg.KillTimerChangeNotice();
			BOOL bRelogin = FALSE;
			if( state == masReloginOK || m_bRetryLoginWithInterval == TRUE )
				bRelogin = TRUE;

			LoadFunctionList();

			if( m_bLogin != TRUE )
				InitLoginSuccess();

			g_stNtalkInfo.eMyStatus = ustONLINE;

			//m_pFrame->InitControls();
			if(m_pFrame)m_pFrame->InitFavoriteList();
			m_bUpdateStatus = TRUE;
			//즐겨찾기 상태 동기화.
			if( state == masReloginOK)
			{
				std::vector<wstring> vecUsers;
				g_pMessengerActor->RequestGetBuddyStatus(vecUsers);
			}
			DisableWindows(FALSE);

			//근태정보 타이머 동작
			KillTimer(TIMER_REFRESH_WORKSTATUS);
			SetTimer(TIMER_REFRESH_WORKSTATUS, 1000 * 60 * 60 * 3, NULL);
			// Unread Note Count
			ProcUnreadNoteCnt();

			// My Chat Room List
			if( bRelogin == FALSE || GET_APP()->m_pChatDialogManager->GetCount() < 1 )
				ProcChatMyRoomList();

			// IPT 권한이 있는 경우만 내 IPT 상태를 요청한다.
			if (GET_CONFIG()->EnableFunction(_T("ME_04")) == TRUE)
			{
				vector<LPCWSTR> vecUser;
				vecUser.push_back( g_pMessengerActor->GetUserID() );
				g_pMessengerActor->RequestPhoneStatus(g_pMessengerActor->GetUserID(), vecUser);
			}

			ProcListNotice();
			ProcGetHanatourCount();

			if( m_bRetryLoginWithInterval )
			{
				GET_APP()->m_pChatDialogManager->SetSessionRecoveryOfAllChatDialog(TRUE);
				m_bRetryLoginWithInterval = FALSE;
			}

			m_IdleMonitor->MonitorSetUserInput(GetSafeHwnd(),WM_DESKTOP_IDLE);
			m_IdleMonitor->MonitorStartUserInput();

			m_LoginDlg.UpdateErrMsg(_T(""));	// 이전 로그인 시도 시 표시된 에러 메세지 제거
			
			if (GET_CONFIG()->GetLegacyBtnInfo().bInfoMail)
			{
				m_pMailModel->SetTicket(g_pMessengerActor->GetMessengerTicket());
				m_pMailModel->CheckNewMail();

				//SetTimer(TIMER_MAIL_CHECK, 1000 * 60 * 2, NULL);	// 2분 마다 메일 체크
				GET_APP()->m_pTimerManager->SetManagedTimer(this, TIMER_MAIL_CHECK, 1000 * 60 * 2/*, &CNeMessengerDlg::CheckNewMail*/);
			}

			GET_APP()->m_pTimerManager->Initialize();

			//ChangeNoticeView();
			//UpdateNoticeView();

		}
		break;
	case masLoginFailed: // 로그인 실패(8)
		{
			m_LoginDlg.DeleteLoadingGIF();
			m_LoginDlg.EnableLoginButton();

			m_bLogin = FALSE;
			m_TrayIcon.SetLogin(FALSE);

			GT_LOGIN_ERROR_DATA sError;
			pActor->GetLoginErrorData(sError);

			NTALK_LOG->Error(L"[LOGIN] LOGIN FAIL!!! errorCode_Server = [%d]\n", sError.errorCode_Server );

			if (sError.errorCode_Server == loginServerError_InvalidPassword || 
				sError.errorCode_Server == loginServerError_InvalidUserID ||
				sError.errorCode_Server == loginServerError_Unknown_Server ||
				sError.errorCode_Server == loginServerError_ETC_Server)
			{
				switch (sError.nNpMsgrDetailErrorCode)
				{
				case WASCODE_AUTH_EMAIL_DUPLICATION:
					m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_EMAILLOGIN));
					break;
				case WASCODE_AUTH_INVALID_CLIENT_VERSION:
					m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING560));
					OnUpdate();
					break;
				case WASCODE_MTS_SERVER_ERROR:
					//IDS_STRING_MTS_SERVER_ERROR is same as IDS_STRING_NEMSGDLG_FAIL_LOGIN in ENG/JPN/ChnT
					m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING_MTS_SERVER_ERROR));
					break;
				default:
					m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_CHECKIDPASSWD));
					if (m_LoginDlg.GetID().IsEmpty())
					{
						m_LoginDlg.SetEditID(TRUE);
					}
					else
					{
						m_LoginDlg.SetEditPassword(TRUE);
					}
					break;
				}
			}
			else if( sError.errorCode_Server == loginServerError_ConnectFailed)
			{
				m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_CONNECTSERVER));
			}
			else if( sError.errorCode_Server == loginServerError_ServerDataError)
			{
				m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_SERVERINTERNALERROR));
			}
			else
			{
				m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_LOGIN));
			}

			// 1. 클라이언트 버전 오류
			// 2. 잘못된 테넌트 이름
			// 3. ID or PW 오류의 및 인증 실패의 경우는 재시도해도 실패이므로, 이 경우가 아닌 경우만 재시도를 해야 한다.
			if (sError.nNpMsgrDetailErrorCode != WASCODE_AUTH_FAIL && 
				sError.nNpMsgrDetailErrorCode != WASCODE_AUTH_INVALID_CLIENT_VERSION &&
				sError.nNpMsgrDetailErrorCode != WASCODE_AUTH_EMAIL_DUPLICATION &&
				sError.nNpMsgrDetailErrorCode != WASCODE_INVALID_TENANT &&
				sError.errorCode_Server != loginServerError_InvalidPassword && 
				sError.errorCode_Server != loginServerError_InvalidUserID)
			{
				if (m_bRetryLoginWithInterval || g_stNtalkInfo.bAutoLogin)
				{
					SetTimer(TIMER_RETRY_LOGIN, m_nRetryLoginInterval, NULL);
				}
			}
		}
		break;
	case masDisconnected:
	case masReloginFailed:
		{
			//DeInitialize();

			//DisableWindows(TRUE);

			//m_LoginDlg.DisableLoginButton();
			//m_LoginDlg.ShowLoadingGIF();
			m_bUpdateStatus = FALSE;
		}
		break;
	case masNetNotAvailable:
		{
			m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_CONNECTSERVER));
			if (FALSE == m_TrayIcon.SetIcon(GET_APP()->GetMyPresenceTrayIconResourceID(ustOFFLINE)))
			{
				m_TrayIcon.AddToTray();
			}
			
			DeInitialize();

			DisableWindows(TRUE);
		}
		break;
	case masFreshTicketFailed:
		{
			DeInitialize();
			DisableWindows(TRUE);
			m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING383));
		}
		break;
	case masLogoutOK: // 로그아웃
		{
			NTALK_LOG->Debug(L"[MAIN] LogoutOK");
			GTLogoutReasonType lort = g_pMessengerActor->GetLogoutReasonType();
			if( lortByDuplicate == lort || lortByNotAvailableNetwork == lort || lortByMsgrLoginFail == lort )
			{
				if( lortByDuplicate == lort )
				{
					m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING105));
					CloseChildAll();
				}
				else if( lortByNotAvailableNetwork == lort || lortByMsgrLoginFail == lort )
					m_LoginDlg.UpdateErrMsg(LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_CONNECTSERVER));

				if (FALSE == m_TrayIcon.SetIcon(GET_APP()->GetMyPresenceTrayIconResourceID(ustOFFLINE)))
				{
					m_TrayIcon.AddToTray();
				}
				
			}
			else
				CloseChildAll();

			DeInitialize();
			m_LoginDlg.StartTimerChangeNotice();
		}
		break;
	}

	return false;
}

bool CNeMessengerDlg::OnGTMessengerActor_GetBuddyStatusNotify(IGTMessengerActor *pActor, std::map<WSTRING, BYTE> &m_mapBuddyInfo)
{
	CStringArray arrUser;

	std::map<WSTRING, BYTE>::iterator itr = m_mapBuddyInfo.begin();
	for(; itr != m_mapBuddyInfo.end(); itr++)
	{
		arrUser.Add( itr->first.c_str() );
	}

	if (arrUser.GetSize() <= 0)
	{
		//GET_APP()->m_pMessageBoxManager->CreateMessageBox(this, LoadStringFromResource(IDS_STRING230));
		NMessageBox(CWnd::GetDesktopWindow(), LoadStringFromResource(IDS_STRING230));
		return true;
	}

	GET_APP()->m_pChatDialogManager->CreateUserIDArrayChat(arrUser);

	return true;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseNoticeList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, 
																		const std::vector<NE_NOTICE_DATA> &listNoticeData)
{	
	if (eErrorCode != wasError_None)
		return false;

	if(listNoticeData.empty() == false)
	{
		std::vector<NE_NOTICE_DATA>::const_iterator iter = listNoticeData.begin();
		if(m_pFrame)m_pFrame->StartNoticeList(listNoticeData);
	}

	return false;
}


bool CNeMessengerDlg::OnGTWASActor_ResponseBannerList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, 
																		const std::vector<NE_BANNER_DATA> &listBannerData)
{
	if (eErrorCode != wasError_None)
		return false;

	if (m_pFrame != NULL)
	{
		m_pFrame->SetBannerList(listBannerData);
		m_pFrame->SetTimer(REFRESH_BANNER_LIST, 10 * 60 * 1000);
	}

	return false;
}


bool CNeMessengerDlg::OnGTWASActor_ResponseGetHanatourCount(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, 
																					const std::vector<NE_HANATOUR_COUNT> &listHanatourCount)
{
	if (eErrorCode == wasError_None)
	{
		std::vector<NE_HANATOUR_COUNT>::const_iterator hanatourCountIter = listHanatourCount.begin();

		for (; hanatourCountIter != listHanatourCount.end(); hanatourCountIter++)
		{
			if(m_pFrame)m_pFrame->SetInfoItemCount(hanatourCountIter->enumHanatourCountType, hanatourCountIter->nCount, hanatourCountIter->strLinkUrl.c_str());
		}
	}
	return false;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseOutLinkList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, 
																		const std::vector<NE_OUTLINK_DATA> &listOutLinkData)
{
	if (eErrorCode == wasError_None)
	{
		if (listOutLinkData.empty() == false)
		{
			GET_CONFIG()->LoadOutLinkList(listOutLinkData);
		}

		if(m_pFrame)m_pFrame->RedrawOutlink();
	}

	return false;
}
bool CNeMessengerDlg::OnGTWASActor_ResponseRefreshTicket(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, LPCWSTR strSession)
{
	if (eErrorCode == wasError_None)
	{	
		char* szTicket = StringToChar(strSession);

		if (NULL != szTicket)
		{
			g_pMessengerActor->SetMessengerTicket(szTicket);
			delete [] szTicket;
		}
	}
	else if (eErrorCode == wasError_Auth)	// 인증 실패의 경우는 로그아웃 시킨 후 재 로그인을 하도록 한다.
	{
		NTALK_LOG->Debug(L"[LOGIN] REFRESHTICKET [%d][%d]", (int)eErrorCode, trid.GetID());
		DeInitialize();
		DisableWindows(TRUE);
		RequestLogoutWithoutClosingWindows(lortByTicketRefreshFail);
	}
	else	// 인증 실패는 아니지만 티켓 갱신을 하지 못한 경우(타임아웃 등의 에러)는 1분 후 다시 시도한다.
	{
		NTALK_LOG->Debug(L"[LOGIN] REFRESHTICKET [%d][%d]", (int)eErrorCode, trid.GetID());
		if(m_pFrame)m_pFrame->KillTimer(REFRESH_TICKET_TIMER);
		if(m_pFrame)m_pFrame->SetTimer(REFRESH_TICKET_TIMER, 60 * 1000); //, NULL);
	}

	return false;
}

int __cdecl CNeMessengerDlg::ItemComareFunc(void *pvlocale,const void *elem1, const void *elem2)
{
	if (!pvlocale || !elem1 || !elem2)
		return 0;

	NE_MYROOM_DATA *p1 = (NE_MYROOM_DATA*)elem1;
	NE_MYROOM_DATA *p2 = (NE_MYROOM_DATA*)elem2;

	int time1 = p1->nLastMsgTime;
	int time2 = p2->nLastMsgTime;
	int nRet = 0;
	if(time1 > time2)
	{
		nRet = 1;
	}
	else
	{
		nRet = -1;
	}

	return nRet;
}

bool CNeMessengerDlg::BeginUpdateAllChatUsersInRoomList()
{
    ASSERT(m_OldChatUsersInRoomList.empty());
    m_OldChatUsersInRoomList = m_AllChatUsersInRoomList; //backup old chat list

    m_AllChatUsersInRoomList.clear();
    return true;
}

bool CNeMessengerDlg::UpdateAllChatUsersInRoomList(const chatroomlist_t& chatUsers)
{
    bool bChanged = false;
    for (chatroomlist_t::const_iterator iterUser = chatUsers.begin();
        iterUser != chatUsers.end();
        ++iterUser)
    {
        const NE_CHATMEMBER_DATA& chatMember = *iterUser;
        ChatUsersInRoomListContainer::iterator iterForPOI = m_AllChatUsersInRoomList.find(chatMember.strID);
        if (m_AllChatUsersInRoomList.end() == iterForPOI)
        {
            //find a new 
            bChanged = true;
            m_AllChatUsersInRoomList.insert(chatMember.strID);
        }
    }
    return bChanged;
}

bool CNeMessengerDlg::EndUpdateAllChatUsersInRoomList()
{
    bool bChanged = false;
    if (m_AllChatUsersInRoomList.size() != m_OldChatUsersInRoomList.size())
    {
        bChanged = true;
    }
    else
    {
        //loop and check -- 
        ChatUsersInRoomListContainer::iterator iterOld = m_OldChatUsersInRoomList.begin();
        for (ChatUsersInRoomListContainer::iterator iterAll = m_AllChatUsersInRoomList.begin();
            iterAll != m_AllChatUsersInRoomList.end();
            ++iterAll)
        {
            if (*iterAll != *iterOld)
            {
                bChanged = true;
                break;
            }
            ++iterOld;
        }
    }

    if (bChanged)
    {
        //chat user in room list has changed, so will register POI again
        g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_CHATROOMLIST);
        std::vector<WSTRING> vecUsers;
        std::copy(m_AllChatUsersInRoomList.begin(), m_AllChatUsersInRoomList.end(), back_inserter(vecUsers));
        g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_CHATROOMLIST);
    }

    m_OldChatUsersInRoomList.clear();

    return bChanged;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseGetMyRoomList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NE_MYROOM_DATA> &listMyRoom)
{
    std::wostringstream os;
#if 1
    //debug for NTALKCL-913
    {
        GT_MY_USER_DATA myUserData;
        g_pMessengerActor->GetMyUserInfo(myUserData);
        for (std::vector<NE_MYROOM_DATA>::const_iterator iterRoom = listMyRoom.begin();
            iterRoom != listMyRoom.end();
            ++iterRoom)
        {
            const chatroomlist_t& memList = iterRoom->listChatMemberData;
            if (iterRoom != listMyRoom.begin())
            {
                os << L",";
            }
            os << L"[" << iterRoom->nRoomID << L":"  << iterRoom->nRoomType << L":" << memList.size() << L":";
            for (chatroomlist_t::const_iterator iterUser = memList.begin();
                iterUser != memList.end(); iterUser ++)
            {
                if (iterUser->strID != myUserData.strUserID)
                {
					os << iterUser->strID << L":" << iterUser->strName << L",";
                }
            }
            os << L"]";
        }
    }
#endif 
    std::wstring strRoomList = os.str();
    NTALK_LOG->Debug(L"[CHAT] GETROOMLIST %d:%d:%d(%s)", (int)eErrorCode, trid.GetID(), listMyRoom.size(), strRoomList.c_str());

	if (eErrorCode == wasError_None)
	{
		if (listMyRoom.empty() == true)
			return false;

        qsort_s((void*)&(listMyRoom.at(0)), listMyRoom.size(), sizeof(NE_MYROOM_DATA), ItemComareFunc, this);
		std::vector<NE_MYROOM_DATA>::const_iterator room_iter = listMyRoom.begin();

        BeginUpdateAllChatUsersInRoomList();

		while(room_iter != listMyRoom.end()){

			/* 비정상 종료된 대화방은 일단 생성을 하고 아래의 경우만 퇴장처리 한다.
			 * 1. 1:1 대화방이고 이전 대화가 전혀 없는경우(방 생성 후 초대만 되어있는 상태)
			 * 2. 단체 대화방에서 모두 퇴장하고 나 혼자 남은 경우
			 */
			
			NE_MYROOM_DATA roomData = *room_iter;
			if (!roomData.strLastMsg.empty() )
			{
				GET_APP()->m_pChatDialogManager->AddRecentChatRoomData(roomData);
				if (m_pFrame)
				{
					m_pFrame->AddChatRoomList(roomData);
				}
			}
            UpdateAllChatUsersInRoomList(roomData.listChatMemberData);
 
           room_iter ++;
		}
		if (m_pFrame)
		{
			m_pFrame->RemoveChatRoomForTimeout();
		}
        EndUpdateAllChatUsersInRoomList();
	}

	return false;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseUnreadNoteCount(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nUnreadNoteCount)
{
	if (eErrorCode != wasError_None)
		return false;

	CString str, strString;
	if (nUnreadNoteCount < 1)
	{
		//쪽지 건수가 정상적이지 않을 경우 -값을 리턴해준다.
		//하지만 실제 UI에서 0을 출력해야 한다.
		nUnreadNoteCount = 0;
	}
	else
	{

		if (GET_CONFIG()->GetNotifyOnMailOrSMS())
		{
			strString.LoadString(IDS_STRING170);
			str.Format(strString, nUnreadNoteCount);
			TRAYPOPUP(TDT_USEAGE, _T(""), str,  this, WM_COMMAND, (PVOID)MAKEWPARAM(IDC_NOTE_LABEL, STN_CLICKED));
		}
		

		if (GET_CONFIG()->GetAutoMessageView() == 1)
		{
			if(m_pFrame)m_pFrame->DoInfoItemNote();
		}
	}

	if(m_pFrame)m_pFrame->SetInfoItemNoteItemCount(nUnreadNoteCount);	

	return false;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseRecvNoteInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NoteInfo &noteInfo, NTReqNoteInfoType reqType, UINT64 noteID)
{
	//트레이 팝업 버그가 나올 수 있다 ㅠ.ㅠ
	//std::list<trid_t>::iterator findTrid = std::find(m_tridListRecvNoteInfo.begin(), m_tridListRecvNoteInfo.end(), trid);
	//if (findTrid == m_tridListRecvNoteInfo.end())
	//	return true;

	//m_tridListRecvNoteInfo.remove(*findTrid);

	
	if (eErrorCode != wasError_None)
	{
		NTALK_LOG->Error(L"[NOTE] ResponseRecvNoteInfo  %d, %d ", (int)eErrorCode, (int)reqType);
		RetryRecvNoteInfo(noteID);
		return false;
	}

	NTALK_LOG->Debug(L"[NOTE] ResponseRecvNoteInfo  %d, %d ", (int)eErrorCode, (int)reqType);
	DeleteRetryRecvNoteInfo(noteID);

	if( reqType == reqNoteInfoType_MakeRecvDlg )
	{
		GET_APP()->m_pReceivedNoteManager->MakeMemoRecvDlg(noteID, noteInfo);
	}
	else if( reqType == reqNoteInfoType_TrayPopup )
	{
		CString strNoteInfo;
        CString strUserName = Conversion::Utf8ToWide(noteInfo.sender.userName).c_str();
        CString strUserId = Conversion::Utf8ToWide(noteInfo.sender.userId).c_str();
		strNoteInfo.Format(L"%s %s\n",LoadStringFromResource(IDS_STRING462), strUserName);
		strNoteInfo.AppendFormat(L"%s %s",LoadStringFromResource(IDS_STRING463), Conversion::Utf8ToWide(noteInfo.title).c_str());

		if (strNoteInfo.IsEmpty())
		{
			NTALK_LOG->Error(L"[NOTE] RecvNoteInfo is empty");
		}
		else
		{
			int nAlarmType = GET_CONFIG()->GetMemoAlarmType();
			if (3 != nAlarmType)
			{
				if(nAlarmType == 0)//트레이알림
				{
					if (GET_CONFIG()->GetNotifyOnMailOrSMS() )
					{
						TRAYPOPUP(TDT_RECEIVE_NOTE, strUserId,
                            strNoteInfo, this, WM_CLICKMEMOPOPUP, (PVOID)noteID);		

					}
				}
				else //작업표시줄 알림.
				{
					if (GET_APP()->m_pReceivedNoteManager->DlgSpaceCount() > 0)
					{
						bool alertEffect = (GET_CONFIG()->GetNotifyOnMailOrSMS()) >0 ? true:false;
						if (alertEffect)
						{
							TRAYPOPUP(TDT_RECEIVE_NOTE, strUserId, strNoteInfo, this, WM_CLICKMEMOFOCUS, (PVOID)noteID);
						}
						GET_APP()->m_pReceivedNoteManager->MakeMemoRecvDlg(noteID, noteInfo);
					}
					else
					{
						CString strMsg = LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_NEWNOTE);

						TRAYPOPUP(TDT_USEAGE, strUserId, strMsg, this, WM_NOTEDLGMAX, NULL);
					}
				}
			}
		}
	}

	return false;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseSetCallInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nCallSeq)
{
	if (eErrorCode != wasError_None)
		return false;

	m_sCallData.nCallSeq = nCallSeq;

	return false;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseNameSearchList( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_SEARCH_MEMBER_DATA_LIST &list )
{
	std::map<trid_t, CString>::const_iterator itr = m_tridMapIPTSearch.find(trid);
	if (itr == m_tridMapIPTSearch.end())
		return true;
	else
	{
		CString strTelNo = itr->second;
		m_tridMapIPTSearch.erase(itr);
		if (eErrorCode == wasError_None && list.nSize == 1)
		{
			const NE_MEMBER_DATA &sMemberInfo = list.pList[0];

			TRAYPOPUP_IPT(TDT_IPT_EMPLYEE_INFO,sMemberInfo.strUserId.c_str(), sMemberInfo.strName.c_str(), sMemberInfo.strExtesion.c_str(), sMemberInfo.strJobPos.c_str(), sMemberInfo.strJobDuty.c_str(), sMemberInfo.strDept.c_str(), this, NULL,NULL);

		}
		else
		{
			TRAYPOPUP_IPT(TDT_IPT_NO_EMPLYEE,L"",strTelNo,L"",L"",L"",L"",this, NULL, NULL);
		}
		return false;
	}
}

LRESULT CNeMessengerDlg::OnMemoTrayPopup(WPARAM wParam, LPARAM lParam)
{
	UINT64 noteID = (UINT64) wParam;

	if (NULL != GET_APP()->m_pReceivedNoteManager)
	{
		GET_APP()->m_pReceivedNoteManager->MakeMemoRecvDlg(noteID);
	}

	return 0;
}

LRESULT CNeMessengerDlg::OnMemoTrayPopupFocus(WPARAM wParam, LPARAM lParam)
{
	UINT64 noteID = (UINT64) wParam;

	if (NULL != GET_APP()->m_pReceivedNoteManager)
		GET_APP()->m_pReceivedNoteManager->SetDlgRestore(noteID);

	return 0;
}
LRESULT CNeMessengerDlg::OnMailTrayPopup( WPARAM wParam, LPARAM lParam )
{
	if(m_pFrame)
	{
		m_pFrame->DoInfoItemMail();
	}

	return 0;
}



LRESULT CNeMessengerDlg::OnBuddyOnlineTrayPopup(WPARAM wParam, LPARAM lParam)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo((int)wParam);
	GET_APP()->m_pChatDialogManager->CreateSingleBuddyChat(pUser);

	return 0;
}

bool CNeMessengerDlg::OnGTMessengerActor_NotifyRecvNote(IGTMessengerActor *pActor, 
												    const ULONGLONG& lNoteId, 
													const LPCWSTR strFromID, 
													const LPCWSTR strFromName, 
													const ULONG &nUnreadNoteCnt)
{

	NTALK_LOG->Debug(L"[NOTE] strFromID = %s, strFromName =%s nUnreadNoteCnt= %lu.", strFromID, strFromName, nUnreadNoteCnt);
	
	if (NULL == GET_APP()->m_pReceivedNoteManager)
		return false;

	// 안 읽은 쪽지 수
	if(m_pFrame)m_pFrame->SetInfoItemNoteItemCount(nUnreadNoteCnt);

	trid_t trid;
	g_pMessengerActor->GetWASActor()->RequestGetRecvNoteInfo(lNoteId, reqNoteInfoType_TrayPopup, GetLanguageString().c_str(),false, &trid);
	m_tridListRecvNoteInfo.push_back(trid);
	return true;
}

bool CNeMessengerDlg::OnGTMessengerActor_NotifyRecvUnreadNoteCnt(IGTMessengerActor *pActor, const ULONG& lUnreadCnt)
{
	//TRACE("%s %d\n", __FUNCTION__, __LINE__);

	NTALK_LOG->Debug(L"[NOTE] NotifyRecvUnreadNoteCnt lUnreadCnt= %lu", lUnreadCnt);

	if(m_pFrame)m_pFrame->SetInfoItemNoteItemCount(lUnreadCnt);
	
	return true;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseMailCount(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, NTNMailErrorCode eNMailError, const INT64 ulPrevMailSN, const INT64 ulMailCountData)
{
	if( eErrorCode != wasError_None )
	{
		return false;
	}

	// 인증 에러인 경우 티켓을 갱신한다.
	if( eNMailError == nmailError_Session )
	{
		if(m_pFrame)m_pFrame->KillTimer(REFRESH_TICKET_TIMER);
		if(m_pFrame)m_pFrame->SetTimer(REFRESH_TICKET_TIMER, 1000); //, NULL);

		return false;
	}
	
	if( eNMailError != nmailError_None )
	{
		return false;
	}

	if( ulPrevMailSN < 0 || ulMailCountData < 0 )	//  lastMailSN 또는 totalUnreadMail 값이 하나라도 "-1", 즉 오류이면 FAIL(from 메일 개발팀)
	{
		; // do nothing. try to retrieve mail information in next timer event.
	}
	else
	{
		bool bInitialize = false;
		if( m_pMailModel->GetUnReadMailCount() == -1 )
			bInitialize  = true;

		m_pMailModel->SetUnReadMailCount(ulMailCountData);
		if(m_pFrame)m_pFrame->SetInfoItemMailItemCount((int)m_pMailModel->GetUnReadMailCount());

		if( bInitialize )
		{
			m_pMailModel->SetPrevMailSerialCache( ulPrevMailSN );
			return false;
		}

		m_pMailModel->SetCurrMailSerialCache( ulPrevMailSN );

		if( m_pMailModel->HasNewMail() )
		{
			if (ulPrevMailSN != 0)
			{
				g_pMessengerActor->GetWASActor()->RequestMailPreview(ulPrevMailSN);

			}

			m_pMailModel->SetPrevMailSerialCache( ulPrevMailSN );
		}
	}

	return false;
}

bool CNeMessengerDlg::OnGTWASActor_ResponseMailPreview(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, LPCWSTR strSubject, LPCWSTR strContent, LPCWSTR strSenderName, LPCWSTR strSenderID)
{
	if (eErrorCode != wasError_None)
		return false;
    
	CString str;
	str.Format(_T("%s %s\n\n %s %s\n"), LoadStringFromResource(IDS_STRING462), strSenderName, LoadStringFromResource(IDS_STRING463), strSubject);
	TRAYPOPUP(TDT_RECEIVE_MAIL, strSenderName, str, this , WM_TRAY_CLICK_MAIL, NULL);

	return false;
}

void CNeMessengerDlg::OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{	
	HMENU hMenu = AfxGetThreadState()->m_hTrackingMenu;
	CMenu	*pMenu = CMenu::FromHandle(hMenu);
	pMenu->MeasureItem(lpMeasureItemStruct);

	CSkinDialog::OnMeasureItem(nIDCtl, lpMeasureItemStruct);
}

void CNeMessengerDlg::OnSize(UINT nType, int cx, int cy)
{
	__super::OnSize(nType, cx, cy);

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);
	if (m_bLogin)
	{
		if(m_pFrame)m_pFrame->MoveWindow(rcClient, TRUE);
	}
	else if (m_LoginDlg.GetSafeHwnd())
	{
		m_LoginDlg.MoveWindow(rcClient, TRUE);
	}

	CRect rcRePaint(0, 0, 0, 0);
	rcRePaint=rcClient;
	rcRePaint.bottom =120;
	RedrawWindow(&rcRePaint, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
}

int CNeMessengerDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	lpCreateStruct->cx = 360;
	lpCreateStruct->cy = 650;
	if (CSkinDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	return 0;
}


void CNeMessengerDlg::OnNMSendMemo()
{
	GET_APP()->m_pSendNoteManager->MakeMemoSendDlg(_T("new"), 0);
}


LRESULT CNeMessengerDlg::OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu)
{	
	LRESULT lResult;
	if(pMenu && pMenu->IsKindOf(RUNTIME_CLASS(CMenuXP)))
		lResult = CMenuXP::OnMenuChar(nChar, nFlags, pMenu);
	else
		lResult = __super::OnMenuChar(nChar, nFlags, pMenu);
	return lResult;
}

int CNeMessengerDlg::DivideString(CString _strData, CString _strIndex, CStringArray* _arrData)
{
	int nPoint = 0, nResult = 0;
	_arrData->RemoveAll();

	//
	if( _strData.IsEmpty() ) return 0;

	while(nPoint >= 0){
		nResult++;
		nPoint = _strData.Find(_strIndex);
		if(nPoint < 0){
			_arrData->Add(_strData);				
			break;
		}
		_arrData->Add(_strData.Left(nPoint));
		_strData = _strData.Right(_strData.GetLength()-nPoint-_strIndex.GetLength());
	}	

	return nResult;
}

int CNeMessengerDlg::DivideString(CString _strData, CString _strIndex, std::vector<std::wstring> &vecUsers)
{
	CStringArray arrUser;
	int nCount = DivideString(_strData, _strIndex, &arrUser);

	for(int i = 0; i < arrUser.GetCount(); i++)
	{
		vecUsers.push_back(arrUser[i].GetString());
	}

	return vecUsers.size();
}

BOOL CNeMessengerDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct)
{
	if (!m_bLogin)
	{
		NMessageBox(GetDesktopWindow(), LoadStringFromResource(IDS_STRING153));
		return FALSE;
	}

	switch(pCopyDataStruct->dwData)
	{
	case COPYDATA_CHAT:
		{
			// users
			int nLen = pCopyDataStruct->cbData;
			CString strUsers = CharToString((char*)pCopyDataStruct->lpData).MakeLower();

			std::vector<wstring> vecUsers;
			DivideString(strUsers, _T(","), vecUsers);

			if (vecUsers.size() > MAX_CHAT_USER)
			{
				//GET_APP()->m_pMessageBoxManager->CreateMessageBox(GetDesktopWindow(), LoadStringFromResource(IDS_STRING157));
				NMessageBox(CWnd::GetDesktopWindow(), LoadStringFromResource(IDS_STRING157));
				return FALSE;
			}

			if (vecUsers.size() <= 0)
			{
				//GET_APP()->m_pMessageBoxManager->CreateMessageBox(GetDesktopWindow(), LoadStringFromResource(IDS_STRING230));
				NMessageBox(CWnd::GetDesktopWindow(), LoadStringFromResource(IDS_STRING230));
				return FALSE;
			}

			g_pMessengerActor->RequestGetBuddyStatus(vecUsers);
		}
		break;
	case COPYDATA_MEMO:
		{
			CString strReceive = CharToString((char*)pCopyDataStruct->lpData);

			CStringArray arrUsersnData;
			DivideString(strReceive, _T("|"), &arrUsersnData);

			CString strUsers = arrUsersnData.GetAt(0);
			CString strTitle  = arrUsersnData.GetAt(1);
			CString strData  = arrUsersnData.GetAt(2);

			CStringArray arrToUserID;
			int nCount = DivideString(strUsers, _T(","), &arrToUserID);

			std::vector<ReceiverInfo> receiverVector;
			for (int index = 0; index < arrToUserID.GetCount(); index++)
			{

				ReceiverInfo receiverInfo;
				CString strID =arrToUserID.GetAt(index);
				receiverInfo.strID = strID.MakeLower();

				const NE_MEMBER_DATA *data = g_pMessengerActor->GetEmployeeInfo(receiverInfo.strID.c_str());
				if (data)
					receiverInfo.strName =  data->strName.c_str();

				receiverVector.push_back(receiverInfo);
			}

			GET_APP()->m_pSendNoteManager->PreMakeMemoSendDlg(receiverVector,strTitle,strData);
		}
		break;
	}

	return __super::OnCopyData(pWnd, pCopyDataStruct);
}


BOOL CNeMessengerDlg::DeInitialize()
{
    NTALK_LOG->Debug(L"[MAIN] DeInitialize");
    KILLALLTRAYPOPUP(); 

	m_bUpdateStatus = FALSE;
	KillTimer(TIMER_NOTICE_CHANGE_POPUP);
	KillTimer(TIMER_REFRESH_WORKSTATUS);
	GET_APP()->m_pTimerManager->KillManagedTimer(this, TIMER_MAIL_CHECK);

	m_bLogin = FALSE;
	m_TrayIcon.SetLogin(FALSE);
	g_stNtalkInfo.eMyStatus = ustOFFLINE;

	GET_APP()->DisableIPT();
	m_bRequestPhoneStatus = FALSE;

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);
	int cxClient = rcClient.Width();
	
	if (m_pFrame!=NULL && m_pFrame->GetSafeHwnd())
	{
		m_pFrame->Unsubclass();
		m_pFrame->OnFinalMessage(m_pFrame->GetHWND());
		delete m_pFrame;
		m_pFrame = NULL;
	}

	ModifyStyle(0, WS_CAPTION);
	ModifyStyle(WS_MAXIMIZEBOX, 0);
	m_LoginDlg.MoveWindow(rcClient);
	m_LoginDlg.EnableWindow(TRUE);
	m_LoginDlg.ShowWindow(SW_SHOW);
	
	ResotoreLoginWindow();

	m_LoginDlg.GetDlgItem(IDC_LOGINPW_EDIT)->EnableWindow(TRUE);
	
	CRect rcWindow(0, 0, 0, 0);
	GetWindowRect(rcWindow);
	rcWindow.bottom += 1;
	MoveWindow(rcWindow);
	
	ShowCustomBtn(false);
	
	if (m_pFrame->GetSafeHwnd())
	{
		m_pFrame->ShowWindow(false, false);//SW_HIDE);
		m_pFrame->DestroyWindow();
	}

	DrawFrame();

	GET_APP()->m_pTimerManager->Deinitialize();
    CUserImageActor::Instance()->DeleteOldProfileImage();
	return TRUE;
}
void CNeMessengerDlg::OnBnClickedSearchButton()
{

}

int CNeMessengerDlg::DownloadFile(LPCTSTR pszURL, LPCTSTR pszDest)
{
	HINTERNET hInternet = NULL, hURL = NULL;
	int result;
	HANDLE hFile = INVALID_HANDLE_VALUE;
	DWORD dwSize, dwRead, dwWritten, dwTotalWrittenBytes;
	BYTE baBuffer[ 1024 * 10 ];
	int nStatusCode;
	CString strDbg;

	if(pszURL == NULL)
	{
		result = ERROR_INVALID_PARAMETER;		
		goto finish;
	}

	hInternet = InternetOpen(_T("NTalk"), INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
	if( hInternet == NULL )
	{
		result = GetLastError();
		TRACE(_T("InternetOpen()"));
		goto finish;
	}

	hURL = InternetOpenUrl(hInternet, pszURL, NULL, 0, INTERNET_FLAG_RELOAD, 0);
	if(hURL == NULL)
	{
		result = GetLastError();
		TRACE(_T( "InternetOpenUrl()"));
		goto finish;
	}

	dwSize = sizeof(baBuffer);
	result = HttpQueryInfo(hURL, HTTP_QUERY_STATUS_CODE, baBuffer, &dwSize, NULL);
	if( result == FALSE )
	{
		result = GetLastError();
		TRACE(_T( "HttpQueryInfo()"));
		goto finish;
	}

	nStatusCode = _ttoi((LPCTSTR)baBuffer);
	if( nStatusCode == 404 )
	{
		//
		// 못찾으면, 그냥 스킵
		//		
		result = ERROR_NOT_FOUND;
		strDbg.Format(_T("file not found: %s"), pszURL );
		TRACE(strDbg);
		goto finish;
	}
	else if((nStatusCode != 200) && (nStatusCode != 304))
	{

		result = GetLastError();
		strDbg.Format(_T("response from webserver: %d" ), nStatusCode);
		TRACE(strDbg);
		goto finish;
	}

	hFile = CreateFile(pszDest, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if( hFile == INVALID_HANDLE_VALUE )
	{	
		DeleteFile(pszDest);
		hFile = CreateFile(pszDest, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFile == INVALID_HANDLE_VALUE )
		{
			result = GetLastError();
			strDbg.Format(_T( "fail to create file: %s" ), pszDest);
			TRACE(_T( "CreateFile() : "));
			TRACE(strDbg);
			goto finish;
		}		
	}

	dwTotalWrittenBytes = 0;

	do
	{
		result = InternetQueryDataAvailable(hURL, &dwSize, 0, 0);
		if( result == FALSE )
		{
			result = GetLastError();
			TRACE(_T( "InternetQueryDataAvailable()"));
			goto finish;
		}

		//
		// 버퍼가 넘어갈 것을 대비해서...
		//
		if( dwSize > sizeof(baBuffer) )
		{
			dwSize = sizeof(baBuffer);
		}

		result = InternetReadFile(hURL, baBuffer, dwSize, &dwRead);
		if(result == FALSE)
		{
			result = GetLastError();
			strDbg.Format(_T("InternetReadFile()"));
			OutputDebugString(strDbg);
			goto finish;
		}

		result = WriteFile(hFile, baBuffer, dwRead, &dwWritten, NULL);
		if(result == FALSE)
		{
			result = GetLastError();
			strDbg.Format(_T("WriteFile()"));
			TRACE(strDbg);
			goto finish;
		}

		dwTotalWrittenBytes += dwWritten;
		
	} while(dwRead != 0);

	
	result = 0;

finish:
	if(result != 0)
	{
		TRACE(_T( "CUpdateManager::DownloadFile()"));
	}

	if( hURL != NULL )
	{
		InternetCloseHandle( hURL );
	}

	if( hInternet != NULL )
	{
		InternetCloseHandle( hInternet );
	}

	if( hFile != INVALID_HANDLE_VALUE )
	{
		CloseHandle( hFile );
	}

	return result;
}

void CNeMessengerDlg::CloseModalDlg(BOOL bExceptConfigDlg)
{
    this->CloseAllModalDialog();

	for (int i=0; i<MAX_MESSAGEBOX_COUNT; ++i)
	{
		if(g_hMessageBox[i] != NULL)
		{
			::SendMessage(g_hMessageBox[i], WM_CLOSE, 0, 0);
		}
	}
	if (!bExceptConfigDlg)
	{
		if (m_ConfigDlg.m_hWnd != NULL )
		{
			m_ConfigDlg.OnBnClickedCancelButton();
		}
		if (m_pDlgSetting!=NULL && IsWindow(m_pDlgSetting->GetHWND()))
		{
			m_pDlgSetting->Close();
		}
	}

	if (m_AutoTextConfigDlg.m_hWnd != NULL)
	{
		m_AutoTextConfigDlg.CloseDlg();
	}
}

void CNeMessengerDlg::CloseChildAll()
{
	NTALK_LOG->Debug(L"[MAIN] CloseChildAll");

	CloseModalDlg();

	if (NULL != m_pWorkGroupController) 
	{
		m_pWorkGroupController->Closeview(TRUE);
		m_pWorkGroupController->CloseAddUserDlg();
	}

	if (NULL != m_pProfileDlgController)
		m_pProfileDlgController->CloseAllDlg();

	if (g_pProfileWnd != NULL && IsWindow(g_pProfileWnd->GetHWND()))
	{
		g_pProfileWnd->CloseProfileWnd();
	}

	CloseCallHistoryDlg();

	CNeMessengerApp* pApp = (CNeMessengerApp*)AfxGetApp();

	if (NULL != pApp->m_pChatDialogManager) pApp->m_pChatDialogManager->RemoveAll();
	if (NULL != pApp->m_pSendNoteManager) pApp->m_pSendNoteManager->RemoveAll();
	if (NULL != pApp->m_pReceivedNoteManager) pApp->m_pReceivedNoteManager->RemoveAll();
	if (NULL != pApp->m_pSMSDialogManager) pApp->m_pSMSDialogManager->RemoveAll();
	if (NULL != pApp->m_pMessageBoxManager) pApp->m_pMessageBoxManager->RemoveAll();
	if (NULL != pApp->m_pChangeNoticeDialogManager) pApp->m_pChangeNoticeDialogManager->RemoveAll();

	
	CDialPadManager* pManager = CDialPadManager::GetDialpadManager();
	if (pManager)
	{
		pManager->DeleteDialPad();
	}
	
}

void CNeMessengerDlg::OnHotKey(UINT nHotKeyId, UINT nKey1, UINT nKey2)
{
	//ALT + M  should not use hot key, the hot key is global in windows,
	//just response the windows WM_SYSKEYDOWN in main frame.

	/*if(nHotKeyId == m_nHotkeyAltMID)
	{
		CWnd* pWnd = this->GetActiveWindow();
		if(m_bLogin == TRUE && IsIconic() == FALSE && pWnd != NULL)
		{
			SendMessage(WM_CLICKCUSTOMBTN, 0, 0);
		}
	}*/
	__super::OnHotKey(nHotKeyId, nKey1, nKey2);
}

UINT CNeMessengerDlg::OnPowerBroadcast(UINT nPowerEvent, LPARAM nEventData)
{
	NTALK_LOG->Debug(L"[MAIN] PowerBroadcast %d:%d", nPowerEvent, nEventData);

	if (nPowerEvent == PBT_APMSUSPEND)
	{
		UnRegisterPeriodicEventThread();
		DisableWindows(TRUE);

		DeInitialize();

		RequestLogoutWithoutClosingWindows(lortByPowerHibernate);
		
	}
	else if(nPowerEvent == PBT_APMRESUMEAUTOMATIC)
	{
		m_LoginDlg.ShowLoadingGIF();

		RetryLoginWithInterval(5000);
		RegisterPeriodicEventThread();
	}

	return __super::OnPowerBroadcast(nPowerEvent, nEventData);
}

bool CNeMessengerDlg::RetryLogin()
{
	NTALK_LOG->Debug(L"[LOGIN] RetryLogin");
	return ProcLogin(g_stNtalkInfo.strId, g_stNtalkInfo.strPassword);
}

void CNeMessengerDlg::RetryLoginWithInterval(UINT nInterval)
{
	m_bRetryLoginWithInterval = TRUE;
	m_nRetryLoginInterval = nInterval;

	KillTimer(TIMER_RETRY_LOGIN);
	SetTimer(TIMER_RETRY_LOGIN, m_nRetryLoginInterval, NULL);
}

void CNeMessengerDlg::DisableWindows( BOOL bStatus )
{
	CNeMessengerApp* pApp = (CNeMessengerApp*)AfxGetApp();
	pApp->m_pChatDialogManager->SetReadOnlyAll(bStatus);

	if (NULL != m_pProfileDlgController)
		m_pProfileDlgController->SetReadOnly(bStatus);

	if (NULL != pApp->m_pSendNoteManager) pApp->m_pSendNoteManager->SetReadOnlyAll(bStatus);
	if (NULL != pApp->m_pReceivedNoteManager) pApp->m_pReceivedNoteManager->SetReadOnlyAll(bStatus);

	if(m_pWorkGroupController) m_pWorkGroupController->SetReadOnly(bStatus);

	//Invalidate();
	//Invalidate는 바로 그려주지 않으므로
	//RedrawWindow UpdateNow로 바로 그려줘 보자.
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}

void CNeMessengerDlg::LogOut()
{
	NTALK_LOG->Debug(L"[LOGIN] LogOut");

	if(m_bLogin == TRUE)
	{	
		//m_pFrame->ReleaseChatRoomList(); it's an empty function;

		CNeMessengerApp* pApp = (CNeMessengerApp*)AfxGetApp();
		int nUnsuccessClosed = pApp->m_pChatDialogManager->GetCountOfChatDlgNotClosed();
        if (nUnsuccessClosed > 0)
        {
			return;
        }

		if(g_pMessengerActor->RequestLogout() == false)
		{
			NMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_REQUESTLOGOUT));
		}
		else
		{
            //int nChatDlgCount = pApp->m_pChatDialogManager->GetVisibleWindowCount();
            //if(nChatDlgCount > 0)
            {
                pApp->m_pChatDialogManager->RemoveAll();			
                // 자동자리비움 모니터 타이머 종료 [2012.5.4 yangjae.park@nhn.com]
                m_IdleMonitor->MonitorStopUserInput();
            }

            g_stNtalkInfo.strPassword.Empty();
			EncryptIdandPasswordToSaveLocal();
			GET_CONFIG()->SaveClientConfig();

            if (FALSE == m_TrayIcon.SetIcon(GET_APP()->GetMyPresenceTrayIconResourceID(ustOFFLINE)))
            {
                m_TrayIcon.AddToTray();
            }
        }
    }
}

void CNeMessengerDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == TIMER_RETRY_LOGIN)
	{
		KillTimer(TIMER_RETRY_LOGIN);
		RetryLogin();
	}
	else if (nIDEvent == TIMER_MAIL_CHECK)
	{
		GET_APP()->m_pTimerManager->OccuredTimerEvent(nIDEvent);

		if (GET_CONFIG()->GetLegacyBtnInfo().bInfoMail)
		{
			m_pMailModel->SetTicket(g_pMessengerActor->GetMessengerTicket());
			m_pMailModel->CheckNewMail();
		}
	}
	else if (nIDEvent == TIMER_REFRESH_TRAYICON)
	{
		if (FALSE == m_TrayIcon.SetIcon(GET_APP()->GetMyPresenceTrayIconResourceID(g_stNtalkInfo.eMyStatus)))
		{
			m_TrayIcon.AddToTray();
		}
	}
	else if(nIDEvent == TIMER_NOTICE_CHANGE_POPUP)
	{
		if (GET_APP()->m_pChangeNoticePushController->IsNoticeDlgDayShow())
		{
			GET_APP()->m_pChangeNoticeDialogManager->CreateNoticeDlg(GET_APP()->m_pChangeNoticeController);
			
		}
		if (GET_APP()->m_pChangeNoticePushController->IsNoticeDlgCheckBeforeShow())
		{
			GET_APP()->m_pChangeNoticeDialogManager->CreateNoticeDlg(GET_APP()->m_pChangeNoticeController);
		
		}

	}
	else if (nIDEvent == TIMER_REFRESH_WORKSTATUS)
	{
		g_pMessengerActor->RequestRefreshWorkStatus();
	}
 
	__super::OnTimer(nIDEvent);
}

bool CNeMessengerDlg::IsLogin()
{
	return m_bLogin ? true : false;
}

bool CNeMessengerDlg::IsRetryLoginWithInterval()
{
	return m_bRetryLoginWithInterval ? true : false;
}

void  CNeMessengerDlg::RequestLogoutWithoutClosingWindows(GTLogoutReasonType reason)
{
	NTALK_LOG->Debug(L"[LOGIN] RequestLogoutWithoutClosingWindows");

	//사용자 창은 놔두고 로그아웃만 실행
	GET_APP()->m_pChatDialogManager->SetSessionRecoveryOfAllChatDialog(FALSE);
	::g_pMessengerActor->RequestLogout(reason);
}

LRESULT CNeMessengerDlg::OnTaskBarCreated(WPARAM wParam, LPARAM lParam)
{
	m_TrayIcon.AddToTray();
	return 0;
}

void CNeMessengerDlg::OnEndSession(BOOL bEnding)
{
	NTALK_LOG->Debug(L"[LOGIN] EndSession");

	__super::OnEndSession(bEnding);

	if (bEnding)
	{
		//종료 되는 순간이므로 자신의 상태를 오프라인으로 변경하여 줌
		ProcChangeMyStatus(ustOFFLINE);
	}
}

void CNeMessengerDlg::OnSessionChange(UINT nSessionState, UINT nId)
{
	AdjustUserStatus(nSessionState);

	__super::OnSessionChange(nSessionState, nId);
}

void CNeMessengerDlg::EncryptIdandPasswordToSaveLocal()
{
	//0. 아이디, 패스워드 암호화
	///////////////////////////////
	CString strEncID = g_stNtalkInfo.strId;
	CString strEndPW = g_stNtalkInfo.strPassword;
	CString strPlainText;
	strPlainText.Format(_T("%s/%s"), strEncID,strEndPW);
	
	// encrypt 버퍼의 사이즈가 16의 배수로 나오기 때문
	int nBufLen = strPlainText.GetLength();
	int nMultiple = nBufLen / 16;
	nBufLen = 16 * (nMultiple + 1);
	/////////////////////////////////////////////////
	
	unsigned char* pszEncSIP = new unsigned char[nBufLen];
	if (NULL != pszEncSIP)
	{
		char* pszPlainText;
		USES_CONVERSION;
		pszPlainText = W2A(strPlainText);
		int nEncSIPSize = EncryptSIP(GetHddSerial(), pszPlainText, pszEncSIP);
		int nLen;
		unsigned char* szEnc = base64_encode(pszEncSIP, nEncSIPSize, &nLen);

		if(pszEncSIP)
		{
			delete [] pszEncSIP;
			pszEncSIP = NULL;
		}

		if(szEnc)
		{
			CString strEnc(szEnc);
			free(szEnc);				
			GET_CONFIG()->SetSIP(strEnc);
		}			
	}
}

void CNeMessengerDlg::NTalkDeInitialize()
{
	PostMessage(WM_NTALK_DEINITIALIZE, (WPARAM)0, (LPARAM)0);
}

void CNeMessengerDlg::InitLoginSuccess()
{
	m_pLanuageActorEvent->RequestSetLanguage(GetLanguageStringUnicode());

	CString strEncMTS;
	strEncMTS.Format(_T("%s/%s"), g_stNtalkInfo.strCorp, g_stNtalkInfo.strDomain);
	GET_CONFIG()->SetSMTS(strEncMTS);
	EncryptIdandPasswordToSaveLocal();
	GET_CONFIG()->SaveClientConfig();			

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);
	

    ModifyStyle(WS_SYSMENU|WS_CAPTION, 0);
	ModifyStyle(0, WS_MAXIMIZEBOX);
	CRect rcWnd(0, 0, 0, 0);
	GetWindowRect(&rcWnd);

	CPoint ptLoginDlg = rcWnd.TopLeft();
	CPoint ptMainDlg = m_rcWindowBeforeLogOut.TopLeft();
	m_rcWindowBeforeLogOut.OffsetRect(ptLoginDlg - ptMainDlg);

	if(!m_bRestore)
	{
		Restore(this, false, _T("MainDialog"), Size, this);
		GetWindowRect(&rcWnd);
		if(!m_bWindowZoomedBeforeLogOut)
		{
			::MoveWindow(m_hWnd, rcWnd.left, rcWnd.top, rcWnd.Width(), rcWnd.Height()+1, TRUE);
		}
		
		m_bRestore = TRUE;
	}
	else
	{	
		GetWindowRect(&rcWnd);
		if(!m_bWindowZoomedBeforeLogOut && m_rcWindowBeforeLogOut.Width() !=0)
		{
			::MoveWindow(m_hWnd, m_rcWindowBeforeLogOut.left, m_rcWindowBeforeLogOut.top, m_rcWindowBeforeLogOut.Width(), m_rcWindowBeforeLogOut.Height()+1, TRUE);
		}
	}
	
	if (m_pFrame == NULL)
	{
		m_pFrame = new MainFrame(this);
	}
	
	if(m_pFrame != NULL) 
	{
		m_pFrame->Subclass(GetSafeHwnd());
		m_pFrame->LoadSkin();
		m_pWorkGroupController->InitView(m_pFrame);
		if(m_bWindowZoomedBeforeLogOut)
		{
			m_pFrame->SendMessage(WM_SYSCOMMAND, SC_MAXIMIZE, 0);
			m_bWindowZoomedBeforeLogOut = false;
		}
		else if(m_rcWindowBeforeLogOut.Width() !=0)
		{
			::MoveWindow(m_pFrame->GetHWND(), m_rcWindowBeforeLogOut.left, m_rcWindowBeforeLogOut.top, m_rcWindowBeforeLogOut.Width(), m_rcWindowBeforeLogOut.Height(), TRUE);
			m_rcWindowBeforeLogOut.SetRectEmpty();
		}
		else
		{
			::MoveWindow(m_pFrame->GetHWND(), rcWnd.left, rcWnd.top, rcWnd.Width(), rcWnd.Height(), TRUE);
		
		}
	}
	//m_pFrame->InitLegacyBtnPos();
//	m_MainDlg.MoveWindow(rcClient, TRUE);

	SetWindowMinSize(DEF_MIN_SIZE_WIDTH, DEF_MIN_SIZE_HEIGHT);

	ShowCustomBtn(true);	// 상단 프레임의 메인 메뉴 버튼
	m_TrayIcon.SetLogin(TRUE);

	// LoginDlg를 먼저 SW_HIDE 할 경우 MainDlg가 그려지는 모습이 사용자에게 보여 느린 느낌을 주기때문에
	// MainDlg가 모두 그려지고 난 후 LoginDlg를 SW_HIDE 하도록 위치 변경
	m_LoginDlg.ShowWindow(SW_HIDE);
	m_LoginDlg.DeleteLoadingGIF();
	m_LoginDlg.EnableLoginButton();
	m_LoginDlg.GetDlgItem(IDC_LOGINPW_EDIT)->EnableWindow(FALSE);
	m_LoginDlg.EnableWindow(FALSE);

	m_bLogin = TRUE;

	// Restore receive note dialog
	if (GET_CONFIG()->GetNoteRecoveryType())
	{
		GET_APP()->m_pReceivedNoteManager->RestoreRecvNote();
	}

	

	//로그 인 후 변경 공지 출력한다.
	if (GET_APP()->m_pChangeNoticeController->IsNoticeDlgLoginShow())
	{
		GET_APP()->m_pChangeNoticeDialogManager->CreateNoticeDlg(GET_APP()->m_pChangeNoticeController);
	}

	SetTimer(TIMER_NOTICE_CHANGE_POPUP, 1000 * 60, NULL);

	::RedrawWindow(GetSafeHwnd(), NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
}

void CNeMessengerDlg::LoadFunctionList()
{
	GT_MY_USER_DATA myUserInfo;
	g_pMessengerActor->GetMyUserInfo(myUserInfo);

	int nAuthCount = GET_CONFIG()->SetMyAuth(&myUserInfo);
	if(m_pFrame)m_pFrame->SetInfoBtnCount(nAuthCount);

	DWORD dwAuth = AUTH_MEMO_NONE;

	if(GET_CONFIG()->EnableFunction(_T("NT_01")) == TRUE)
		dwAuth |= AUTH_MEMO_NT01;

	if(GET_CONFIG()->EnableFunction(_T("NT_02")) == TRUE)
		dwAuth |= AUTH_MEMO_NT02;
	
	GET_APP()->m_pSendNoteManager->SetAuthorize(dwAuth);
}

void CNeMessengerDlg::AdjustUserStatus( UINT nSessionState )
{
	if (WTS_SESSION_LOCK == nSessionState && g_stNtalkInfo.eMyStatus == ustONLINE)
	{
		m_IdleMonitor->PauseMonitorInput();
		ProcChangeMyStatus(ustAUTOAWAY);
	}
	else if (WTS_SESSION_UNLOCK == nSessionState && g_stNtalkInfo.eMyStatus == ustAUTOAWAY)
	{
		ProcChangeMyStatus(ustONLINE);
		m_IdleMonitor->ResumeMonitorInput();
	}
}

void CNeMessengerDlg::RegisterPeriodicEventThread()
{
	if (NULL != m_pPeriodicEventHandler)
		return;

	m_pPeriodicEventHandler = new CPeriodicEventHandler(this);

	if (NULL != m_pPeriodicEventHandler)
	{
		m_pPeriodicEventHandler->start();
	}
}

void CNeMessengerDlg::UnRegisterPeriodicEventThread()
{
	if (NULL != m_pPeriodicEventHandler)
	{
		m_pPeriodicEventHandler->stop();
		delete m_pPeriodicEventHandler;
		m_pPeriodicEventHandler = NULL;
	}
}

bool CNeMessengerDlg::IsCloseMsg( MSG* pMsg )
{
	bool result = false;
	if( (pMsg->message == WM_CLOSE) && pMsg->hwnd == m_hWnd )
		result = true;

	return result;
}

LRESULT CNeMessengerDlg::OnNoteDlgMax( WPARAM wParam, LPARAM lParam )
{
	CString strTicket = CString(g_pMessengerActor->GetMessengerTicket());

	CString strLang = _T("");
	if(m_pFrame)strLang = m_pFrame->GetLanguage();

	CString strUrl = _T("");
    strUrl.Format(CServerAddrConfig::Instance().GetMessageUrl() , strTicket, strLang);  //NTALK_MESSAGE_URL

	if (FALSE == CXHyperLink::UseAlreadyOpenedIE(_T("nnote.ncloudbiz.com")))
		CXHyperLink::GotoURL(strUrl, SW_SHOWNORMAL);
	
	return 0L;
}

void CNeMessengerDlg::OnMove(int x, int y)
{
	CSkinDialog::OnMove(x, y);
}

//void CNeMessengerDlg::CloseCallerInfoDlg()
//{
//	if (m_pCallerInfoDlg)
//	{
//		if (m_pCallerInfoDlg->GetSafeHwnd())
//			m_pCallerInfoDlg->DestroyWindow();
//		
//		delete m_pCallerInfoDlg;
//		m_pCallerInfoDlg = NULL;
//	}
//}

void CNeMessengerDlg::CloseCallHistoryDlg()
{
	if (m_pCallHistoryDlg)
	{
		if (m_pCallHistoryDlg->GetSafeHwnd())
			m_pCallHistoryDlg->DestroyWindow();

		delete m_pCallHistoryDlg;
		m_pCallHistoryDlg = NULL;
	}
}

void CNeMessengerDlg::SetCID(LPCWSTR strCID)
{ 
	m_strCID = strCID;
}

CString CNeMessengerDlg::GetCID()
{ 
	return m_strCID; 
}

void CNeMessengerDlg::SetForwardingInfo( BYTE nForwarding, LPCWSTR strTelNo )
{
	SetForwardingStatus(nForwarding);
}

void CNeMessengerDlg::SetForwardingStatus( BYTE nForwarding )
{
	m_nForwardingStatus = nForwarding;
}

BYTE CNeMessengerDlg::GetForwardingStatus()
{
	return m_nForwardingStatus;
}

void CNeMessengerDlg::SetDND( BYTE nStatus )
{
	m_nDndStatus = nStatus;
}

BYTE CNeMessengerDlg::GetDND()
{
	return m_nDndStatus;
}

void CNeMessengerDlg::SetHold( BYTE nStatus )
{
	m_nHoldStatus = nStatus;
}

BYTE CNeMessengerDlg::GetHold()
{
	return m_nHoldStatus;
}

bool CNeMessengerDlg::IsNonAuthorizedUser()
{
	return GET_CONFIG()->GetLegacyBtnInfo().bInfoSign == FALSE &&
		GET_CONFIG()->GetLegacyBtnInfo().bInfoIN == FALSE &&
		GET_CONFIG()->GetLegacyBtnInfo().bInfoSAM == FALSE;
}

void CNeMessengerDlg::RetryRecvNoteInfo( UINT64 noteID )
{
	NTALK_LOG->Debug(L"[NOTE] RetryRecvNoteInfo nUnreadNoteCnt= %lu.",noteID);

	bool bRetryAdd = true;
	std::vector<RETRY_RECVNOTE_INFO>::iterator iter = m_vecRecvNoteRetryInfo.begin();
	for (; iter != m_vecRecvNoteRetryInfo.end(); ++iter)
	{
		RETRY_RECVNOTE_INFO info;
		info = *iter;
		if (info.noteID == noteID)
		{
			bRetryAdd = false;
		}

	}
	if (bRetryAdd)
	{
		RETRY_RECVNOTE_INFO retryInfo;
		retryInfo.noteID = noteID;
		retryInfo.nReTryCount = 0;
		m_vecRecvNoteRetryInfo.push_back(retryInfo);
	}

	iter = m_vecRecvNoteRetryInfo.begin();
	for (; iter != m_vecRecvNoteRetryInfo.end(); ++iter)
	{
		RETRY_RECVNOTE_INFO info;
		info = *iter;
		if (info.noteID == noteID)
		{
			int nCount = info.nReTryCount + 1;
			if (nCount < 3)
			{
				RETRY_RECVNOTE_INFO retryInfo;
				retryInfo.noteID = noteID;
				retryInfo.nReTryCount = nCount;
				m_vecRecvNoteRetryInfo.erase(iter);
				m_vecRecvNoteRetryInfo.push_back(retryInfo);
				trid_t _trid;
				g_pMessengerActor->GetWASActor()->RequestGetRecvNoteInfo(info.noteID, reqNoteInfoType_TrayPopup, GetLanguageString().c_str(),false, &_trid);

				m_tridListRecvNoteInfo.push_back(_trid);
				break;
			}
		}
	}

}

void CNeMessengerDlg::DeleteRetryRecvNoteInfo( UINT64 noteID )
{
	NTALK_LOG->Debug(L"[NOTE] DeleteRetryRecvNoteInfo = %lu.",noteID);

	std::vector<RETRY_RECVNOTE_INFO>::iterator iter = m_vecRecvNoteRetryInfo.begin();
	for (; iter != m_vecRecvNoteRetryInfo.end(); iter++)
	{
		RETRY_RECVNOTE_INFO Info;
		Info = *iter;
		if(Info.noteID == noteID)
		{
			m_vecRecvNoteRetryInfo.erase(iter);
			break;
		}
	}
}

void CNeMessengerDlg::ChangeNoticeView()
{
	//Change Notice
	NE_NOTICE_DATA noticeData;
	noticeData.strTitle = L"";
	noticeData.nSeq = 147;
	if (GET_CONFIG()->GetNoticeViewID() != noticeData.nSeq)
	{
		CString strUrl; 
        //NTALK_NOTICE_URL
        strUrl.Format(CServerAddrConfig::Instance().GetNTalkNoticeUrl(), UrlEncode(g_stNtalkInfo.strCorp), UrlEncode(g_stNtalkInfo.strId), 
            UrlEncode(_T("msn_pc")), UrlEncode((CString)g_pMessengerActor->GetMessengerTicket()), noticeData.nSeq);

		CNoticeController *pNotice = CNoticeController::CreateNotice(strUrl);
		pNotice->ShowNotice();
		GET_CONFIG()->SetNoticeViewID(noticeData.nSeq);
		GET_CONFIG()->SaveClientConfig();
	}
}

void CNeMessengerDlg::UpdateNoticeView()
{
	//Update Notice.
	CString strUpdateNoticeURL = GetUpdateNoticeURL();

	if ( !strUpdateNoticeURL.IsEmpty() && GET_CONFIG()->GetUpdateNoticeURL() != strUpdateNoticeURL && GET_CONFIG()->GetUpdateNoticeViewCount() == 0 )
	{
		CUpdateNoticeController *pNotice = CUpdateNoticeController::CreateNotice(strUpdateNoticeURL);
		pNotice->ShowNotice();
	}

}

CString CNeMessengerDlg::GetUpdateNoticeURL()
{
	CString strUpdateNoticeURL;
	CString strTenant;
	if (g_stNtalkInfo.strDomain == L"nts")
		strTenant = L"nhncorp";
	else
		strTenant = L"hanatour";

		strUpdateNoticeURL = CND_URL + strTenant + UPDATE_NOTICE_PATH;
	
	
	return strUpdateNoticeURL;
}
bool CNeMessengerDlg::OnGTMessengerActor_ResponseUserImage( IGTMessengerActor *pActor, const GT_USER_IMAGE_RESULT_DATA& sData )
{
	return true;
}

BOOL CNeMessengerDlg::UserGivenRect( LPRECT lpRect )
{
	WINDOWPLACEMENT wp;
	GetWindowPlacement(&wp);
	lpRect->left = wp.rcNormalPosition.left;
	lpRect->right = wp.rcNormalPosition.right;
	lpRect->top = wp.rcNormalPosition.top;
	lpRect->bottom = wp.rcNormalPosition.bottom;

	if(IsLogin() && m_pFrame != NULL && m_pFrame->GetSafeHwnd())
	{
		return TRUE;	
	}
	if(!IsLogin() && m_LoginDlg.GetSafeHwnd())
	{
		if(!m_rcWindowBeforeLogOut.IsRectEmpty())
		{
			if(m_bWindowZoomedBeforeLogOut && !m_rcWindowMaxRestore.IsRectEmpty())
			{
				lpRect->left = m_rcWindowMaxRestore.left;
				lpRect->right = m_rcWindowMaxRestore.right;
				lpRect->top = m_rcWindowMaxRestore.top;
				lpRect->bottom = m_rcWindowMaxRestore.bottom;
			}
			else
			{
				lpRect->right = lpRect->left + m_rcWindowBeforeLogOut.right -  m_rcWindowBeforeLogOut.left;
				lpRect->bottom = lpRect->top + m_rcWindowBeforeLogOut.bottom - m_rcWindowBeforeLogOut.top;
			}
			
		}
		
	}

	return TRUE;
}

void CNeMessengerDlg::SetWindowMax()
{
	m_bWindowZoomedBeforeLogOut = true;
}

void CNeMessengerDlg::ResotoreLoginWindow()
{
	if(::IsZoomed(m_hWnd))
	{
		m_bWindowZoomedBeforeLogOut = true;
		WINDOWPLACEMENT wp;
		GetWindowPlacement(&wp);
		m_rcWindowMaxRestore = wp.rcNormalPosition;
	}

	if(::IsIconic(m_hWnd))
	{
		m_rcWindowBeforeLogOut.SetRectEmpty();
	}
	else 
	{
		GetWindowRect(&m_rcWindowBeforeLogOut);
	}

	ShowWindow(SW_RESTORE);

	CRect rcWindow(0, 0, 0, 0);
	GetWindowRect(&rcWindow);
	rcWindow.right = rcWindow.left + DEF_MIN_SIZE_WIDTH;
	rcWindow.bottom = rcWindow.top + DEF_MIN_SIZE_HEIGHT;
	MoveWindow(rcWindow, TRUE);
}

BOOL CNeMessengerDlg::IsAMSWndZoomed()
{
	if(m_bLogin)
	{
		return CWnd::IsZoomed();
	}

	return m_bWindowZoomedBeforeLogOut;
}

BOOL CNeMessengerDlg::IsJustSavePosition()
{
	if(!m_bLogin && m_rcWindowBeforeLogOut.IsRectEmpty())
	{
		return TRUE;
	}

	return FALSE;
}


